head	1.3;
access;
symbols;
locks
	bilbo:1.3; strict;
comment	@ * @;


1.3
date	2003.06.08.17.17.32;	author bilbo;	state Exp;
branches;
next	1.2;

1.2
date	2003.05.31.01.25.57;	author bilbo;	state Exp;
branches;
next	1.1;

1.1
date	2003.05.22.10.26.05;	author bilbo;	state Exp;
branches;
next	;


desc
@@


1.3
log
@*** empty log message ***
@
text
@/***

b_math

Matematicke funkce.
 - funkce na praci s vektory
 - funkce na nahodna cisla

*/
#include "b_math.h"
#include "b_util.h"

#undef istats //vypnuto - statistiky edges //[PASS]

/** pro primku (v1,n1) a rovinu (v2,n2) - bod na rovine/primce a normala/smernice spocte jejich
    prunik a pozici na primce vzhledem k bodu */
geom_intersect intersect_ray_plane(vector v1,vector d1,vector v2,vector n2,ray_plane_intersect *i) {
 bfloat q=v_muls(n2,d1);
 if (q==0.0) return NO_INTERSECT;
 q=v_muls(n2,v_sub(v2,v1))/q;
 i->t=q;
 v_addf(&v1,d1,q);
 i->p=v1;
 if (q<0.0) return INTERSECT_BACK;
 return INTERSECT;
}

#ifdef istats //[PASS]

int st_x0,st_y0,st_z0,st_n,st_det0;//statistiky pruniku primek (debug, optimalizace)

/** spocita statistiky pruniku primek (debugovaci funkce, pro optimalizaci...)*/
void intersect_stats(vector v1,vector p1,vector v2,vector p2) {
 unused(v1);unused(v2);
 if (p1.x==0) st_x0++;
 if (p1.y==0) st_y0++;
 if (p1.z==0) st_z0++;
 if (p1.y*p2.x-p1.x*p2.y==0.0) st_det0++;
 st_n++;
}

/** vytiskne statistiky pruniku primek (debugovaci funkce, pro optimalizaci...)*/
void intersect_stats_p() {
 double st_x,st_y,st_z,st_d;
 st_x=(double)(st_x0*100)/st_n;
 st_y=(double)(st_y0*100)/st_n;
 st_z=(double)(st_z0*100)/st_n;
 st_d=(double)(st_det0*100)/st_n;
 printf("x=%6d y=%6d z=%6d det=%6d sum=%6d\nx=%5g%% y=%5g%% z=%5g%% det=%5g%%\n",st_x0,st_y0,st_z0,st_det0,st_n,st_x,st_y,st_z,st_d);
}
#endif //[PASS]

/** vydeli jeden vektor druhym. Tise predpoklada, ze vektory jsou linearne zavisle a vraci skala (pomer velikosti) */
bfloat v_div(const vector a, const vector b) {
 if (b.x!=0.0) return (a.x/b.x);
 if (b.y!=0.0) return (a.y/b.y);
 if (b.z!=0.0) return (a.z/b.z);
 fatalf("v_div: division by zero ([%g %g %g]/[%g %g %g])",all3d(a),all3d(b));
 return 0;
}

/** pro 2 primky (v1,p1) a (v2,p2) - spocte jejich
    prunik a pozici na primce vzhledem k bodu
 */
geom_intersect intersect_ray_ray(vector v1,vector p1,vector v2,vector p2,ray_ray_intersect *i) {
 ray_plane_intersect p;
 int r;
 vector n2,n3;
#ifdef istats
 intersect_stats(v1,p1,v2,p2);
#endif
 n3=v_mulv(p1,p2);
 n2=v_mulv(p2,n3);
 if (iszero(n3)) {
  if (v_eq_np(v_sub(v1,v2),p1)) return IDENTICAL;//prekryvaji se
  return PARALLEL;//rovnobezky
 } 
 r=intersect_ray_plane(v1,p1,v2,n2,&p);
 if (!(r & INTERSECT)) {
  debug_printf("(<%g %g %g>)\n",all3d(n2));
  debug_printf("(<%g %g %g>, <%g %g %g>) (<%g %g %g>, <%g %g %g>)\n",all3d(v1),all3d(p1),all3d(v2),all3d(p2));
  fatalf("ray_ray: no intersect (%d)!!",r);
 }
 i->a=p.t;
 i->p=p.p;
 i->b=v_div(v_sub(p.p,v2),p2);
 return INTERSECT;
}

/** pro dve roviny (v1,n1) a (v2,n2) - bod na rovine a normala spocte jejich
    prunik a vektory ukazujici z pruniku "dovnitr" poloroviny
    n1 a n2 MUSI byt normalizovane!! */
geom_intersect intersect_plane_plane(vector v1,vector n1,vector v2,vector n2,plane_plane_intersect *i) {
 vector p,q1,q2;
 ray_plane_intersect i2;
 geom_intersect r;
 if (v_eq(n1,n2)) return IDENTICAL; //rovnobezne, stejna normala, nezkouma jestli jsou opravdu identicke
 //TODO: zkoumat jestli jeden neni uplne odriznut (v dobrem .map souboru se tohle nestava)
 if (v_eq_neg(n1,n2)) return NO_INTERSECT;//rovnobezne, opacna normala, nezkouma jestli jsou opravdu identicke
 //TODO: zkoumat jestli jsou ok, nebo jestli chyba (v dobrem .map souboru se tohle nestava)
 v_mulv2(&p,n1,n2); //smernice primky
 v_mulv2(&q1,p,n1); //1.prunik
 v_mulv2(&q2,p,n2); //2.prunik
 r=intersect_ray_plane(v1,q1,v2,n2,&i2);
 if (!(r & INTERSECT)) fatalf("(%d) intersect_ray_plane ([%g %g %g],[%g %g %g] vs [%g %g %g],[%g %g %g]): no intersection (n1=%g %g %g)!",r,all3d(v1),all3d(q1),all3d(v2),all3d(n2),all3d(n1));
 i->p=i2.p;//point
 i->in1=q1;
 i->in2=q2;
// v_mul(&(i->in1),-1);//TAK V TYHLE RADCE BYLA TA $#^$@@#^$@@%^$^@@^$@@#@@@@^@@@@ CHYBA CO JSEM SE S NI MORIL MINIMALNE CELEJ DEN!!!!!!
 v_mul(&(i->in2),-1);
 i->d=p;
 return INTERSECT;
}

/** funkce sgn(x) - vraci znamenko argumentu */
bfloat sgn(bfloat f) {
 if (f<0) return -1;
 if (f>0) return 1;
 return 0;
}

/** zkrasleni vektoru - prodlouzi/zkrati vektor na cela cisla, pokud to lze a pokud je sance ze to pomuze predejit chybam v zaokrouhlovani */
void nice_vector(vector *v) {
 int ix,iy,iz;
 ix=(fabs(v->x)==0);
 iy=(fabs(v->y)==0);
 iz=(fabs(v->z)==0);
 if ((fabs(v->x)==fabs(v->y) || ix || iy)
  && (fabs(v->x)==fabs(v->z) || ix || iz)
  && (fabs(v->z)==fabs(v->y) || iz || iy)) {
  v->x=1*sgn(v->x);
  v->y=1*sgn(v->y);
  v->z=1*sgn(v->z);
 }
}

/** vrati nejmensi kladny integer X, aby platilo i <= X*X */
int msqrt(int i) {
 int j=1;
 while (j*j<i) j++;
 return j;
}

/**
Odmaskovani jistych souradnic vektoru
mask by mela byt mezi 0 a 1 (jednotlive slozky)
pokud je 0, vrati new1, pokud je 1, vrati orig, jinak linearne mezi tim.
Pro kazdou souradnici pracuje zvlast
*/
vector v_mask(vector orig,vector mask,vector new1) {
 orig.x=orig.x*mask.x+new1.x*(1-mask.x);
 orig.y=orig.y*mask.y+new1.y*(1-mask.y);
 orig.z=orig.z*mask.z+new1.z*(1-mask.z);
 return orig;
}

/** prevede retezec na vektor (format "x y z" nebo "X,y,z")*/
vector atov(const char *vstr) {
 float f[3]={0,0,0}; 
 vector v;
 if (sscanf(vstr,"%f %f %f",f+0,f+1,f+2)<3) sscanf(vstr,"%f , %f , %f",f+0,f+1,f+2);
 v.x=f[0];
 v.y=f[1];
 v.z=f[2];
 return v;
}

//generator nahodnych cisel. 
unsigned int randseed; //seed of rtandom number generator

/** inittialization of random number generator */
void bsrandom(void) {
 randseed=gettickcount();
}

/** adjust randseed to next random number in sequence */
void bnextrand(void) {
 randseed*=0x8088405;
 randseed++;
}

/** return random number between 0 and max-1, maximum allowed max is 65536 */
unsigned int brandom(unsigned int max) {
 unsigned int i;
 bnextrand();
 i=(randseed%65536)*max;
 i=i/65536;
 return i;
}

#ifndef _WIN32
//Inline funkce jsou tady - na unixu to funguje normalne
#include "b_math_in.c"
#endif
@


1.2
log
@*** empty log message ***
@
text
@a9 3
#include "bilbo.h"
#include "b_config.h"
#include "b_types.h"
@


1.1
log
@Initial revision
@
text
@d193 5
@
