head	1.5;
access;
symbols;
locks
	bilbo:1.5; strict;
comment	@ * @;


1.5
date	2003.09.10.18.08.33;	author bilbo;	state Exp;
branches;
next	1.4;

1.4
date	2003.08.12.23.11.26;	author bilbo;	state Exp;
branches;
next	1.3;

1.3
date	2003.06.08.15.12.57;	author bilbo;	state Exp;
branches;
next	1.2;

1.2
date	2003.05.31.01.25.57;	author bilbo;	state Exp;
branches;
next	1.1;

1.1
date	2003.05.22.13.10.00;	author bilbo;	state Exp;
branches;
next	;


desc
@@


1.5
log
@*** empty log message ***
@
text
@/***
 funkce pro praci s 3d modely
 nahravani modelu
 vytvareni modelu
 dealokace pameti
 manipulace s bounding boxy
 ruzne jine funkce
*/
#include "config.h"
#include "b_model3d.h"
#include "b_coll.h"
int fatal_loading_error; //pokud je 0, vse je v poradku, jinak to znamena ze pri nahravani neceho (typicky mapy) doslo k chybe...[EXT]

//World funkce

/** vytvori prazdny svet a naalokuje misto pro obj dynamickych objektu */
worldspawn *world_empty(int obj) {
 worldspawn *w;
 w=malloc0(sizeof(worldspawn));
 w->obj.alocobj=obj;
 w->obj.obj=malloc0(obj*sizeof(void*));
 debug_printf0("allocated %d, size %d\n",w->obj.obj,obj*sizeof(void*));
 return w;
}

/** odalokuje v pameti object class
 (zde pouze snizi pocet referenci, k skutecne odalokaci dojde pozdeji,
 az pri zavolani garbage collectoru - typicky po nahrani dalsiho levelu
 se odstani ty veci co v tom levelu nejsou. Tohle bude chtit jeste doresit) */
void freeobjectclass(objectclass *c) {
 exist_or_return(c,"freeobjectclass");//objekty bez class by se vyskytovat nemely
 c->refcount--;
 //TODO: nepouzivane objekty (refcount==0) se seberou nakonci levelu
}

/** odalokuje v pameti properties */
void freeproperties(properties *p) {
 properties *p2;
 while (p) { 
  free(p->k);
  free(p->v);
  p2=p->next;
  free(p);
  p=p2;
 }
}

/** odalokuje v pameti material list */
void freematlist(matlist *t) {
 matlist *q;
 while (t) {
  q=t->next;
  debug_printf0("freematlist: %s %d\n",t->t->name,t->t->ref);
  free(t);
  debug_printf0("freematlist: ok\n");
  t=q;
 }
}


/** odalokuje v pameti linked list */
void freel_list(l_list *t) {
 l_list *q;
 while (t) {
  q=t->next;
  debug_printf0("freel_list: %d\n",t);
  free(t);
  debug_printf0("freel_list: ok\n");
  t=q;
 }
}

/** zduplikuje texture list */
matlist *dupmatlist(matlist *t) {
 matlist *q=0,*o=0;
 while (t) {
  if (o) {
   q->next=malloc1(sizeof(matlist));
   q=q->next;
  } else {
   o=malloc1(sizeof(matlist));
   q=o;
  }
  q->next=0;
  q->t=t->t;
  q->t->ref++;
  t=t->next;
 }
 return o;
}

/** projde texturelist a u kazde textury v nem zvysi refcount (pocet pouziti) o r */
void material_list_use(matlist *t,int r) {
 while (t) {
  debug_printf0("texturelist_use:add %d to %s\n",r,t->t->name);
  t->t->ref+=r;
  t=t->next;
 }
}

/** odalokuje v pameti model */
void freemodel_real(model3d *m) {
 debug_printf0("freemodel_real:enter %d\n",m);
 if (!m) return; //objekty bez modelu jsou pomerne bezne, varovani by to hazet nemelo
 //exist_or_return(m,"freemodel");
 if (m->manager) {
  fatalf("DEBUG: freemodel_real: tyhle veci nemuzou jit pres manager!\n");
 }
 //TODO: nesnazit se o dealokaci tady, ael pozdeji udelat flush
 if (m->call_list) {
  glDeleteLists(m->call_list,1);
 }
 model_unset_materials(m);
 freematlist(m->matl);
 free(m->vert);
 free(m->facev);
 free(m->face);
 free(m);
 debug_printf0("freemodel_real:done\n");
}

/** odalokuje v pameti model - pokud na nej nejsou reference */
void freemodel(model3d *m) {
 debug_printf0("freemodel:enter %d\n",m);
 if (!m) return; //objekty bez modelu jsou pomerne bezne, varovani by to hazet nemelo
 //exist_or_return(m,"freemodel");
 if (m->manager) {
  if (!m->manager->name) {
   debug_printf("freemodel: null model name in manager! (no refcount used)\n");
   return;
   //fatalf("freemodel: null model name in manager!!! BUG!!!\n");
   //TODO: tahle chyba by se nemela nikdy stat
  }
  debug_printf0("freemodel:use manager, refcount=%d\n",m->manager->refcount);
  b_unloadmodel_r(m->manager->name);
  return;//model se pouziva, nelze odalokovat
 }
 //nesnazit se o dealokaci tady, ale pozdeji udelat flush
 //freemodel_real(m);
 debug_printf0("freemodel:done\n");
}

/** odalokuje seznam objektu (jeden po druhem */
void freeobjectlist(objectlist o) {
// object3d **q;
 int i;
 debug_printf0("freeobjectlist:enter %d\n",o.numobj);
// q=o.obj;
 for (i=0;i<o.numobj;i++) {
  debug_printf0(" freeobjectlist:one %d\n",i);
  freeobject(o.obj[i]);//*q
//  q++;
 }
 debug_printf0(" freeobjectlist:want to free list %d\n",o.obj);
 free(o.obj);
 o.obj=0;
 debug_printf0("freeobjectlist:done\n");
}

/** odalokuje objekt vcetne podrazenych stuktur a child objektu. Neodalokuje ale parent */
void freeobject(object3d *o) {
 debug_printf0("freeobject:enter %d\n",o);
 exist_or_return(o,"freeobject");
#ifdef use_ode_lib
 world_destroyobject(o);
#endif
 freeobjectclass(o->type);
 o->type=0;
 freeproperties(o->prop);
 freeobjectlist(o->child);
 freemodel(o->model);
 o->model=0;
 free(o);
 debug_printf0("freeobject:done\n");
}

/** odalokuje cely svet */
void freeworld (worldspawn *w) {
 debug_printf0("freeworld:enter %d\n",w);
 exist_or_return(w,"freeworld");
 debug_printf0("freeworld:before freemodel %d\n",w);
 freemodel(w->m);
 debug_printf0("freeworld:before freeobjectlist %d\n",w);
 freeobjectlist(w->obj);
 debug_printf0("freeworld:before exit %d\n",w);
 free(w);
 debug_printf0("freeworld:done\n");
}

//Funkce na zachazeni s tmpmodely

/** vytvori docasny (pametove neefektivni, ale rychly) model */
tmpmodel *model_begin(void) {
 tmpmodel *q;
 q=malloc0(sizeof(tmpmodel));
 q->maxvert=100;//TODO: odzkouset s jinymi hodnotami a dat jen nastavitelne
 q->maxface=100;
 q->maxpoint=100;
 q->p=malloc0(q->maxpoint*sizeof(facecoord));
 q->v=malloc0(q->maxvert*sizeof(vertex));
 q->f=malloc0(q->maxface*sizeof(modelface));
 return q;
}

/** prida material do seznamu */
void mat_list_addmaterial(matlist **m,material *tex) {
 matlist *t=*m;
 while (t) {
  if (t->t==tex) return; //textura tam jiz je
  t=t->next;
 }
 if (!t) {//zadne textury -> pridat
  t=*m;
  *m=malloc0(sizeof(matlist));
  (*m)->t=tex;
  (*m)->next=t;
 }
}

/** prida tex do linked listu */
void l_list_add(l_list **m,void *tex) {
 l_list *t=*m;
 while (t) {
  if (t->t==tex) return; //textura tam jiz je
  t=t->next;
 }
 if (!t) {//zadne textury -> pridat
  t=*m;
  *m=malloc0(sizeof(l_list));
  (*m)->t=tex;
  (*m)->next=t;
 }
}


//TODO: material manager

/** vytvori material s danymi parametry a nastavi reference count na 1 */
material *mat_create(byte r,byte g,byte b,byte alpha,texture *texture1) {
 material *m=malloc0(sizeof(material));
 m->color[0]=r;
 m->color[1]=g;
 m->color[2]=b;
 m->color[3]=alpha;
 m->tex=texture1;
 if (texture1) texture1->refcount++;
 m->ref=0;
 return m;
}

/** odalokuje material, pokud uz na nej nikde nic neukazuje */
void mat_free(material *m) {
 m->ref--;
 if (m->ref<=0) {
  if (m->tex) m->tex->refcount--;//todo: maybe free/flush
  if (m->name) free(m->name);//jemno materialu
  free(m);
 }
}

/** zacatek facu */
void model_face_begin_mat(tmpmodel *m, material *mat) {
 int i=m->numface;
 if (i==m->maxface) {
  m->maxface*=2;
  m->f=realloc1(m->f,m->maxface*sizeof(modelface));
 }
 m->f[i].m=mat;
 if (mat) model_material_used(m,mat);
 m->f[i].ncoord=0;
 m->numface++;
}

/** zacatek facu */
void model_face_begin_id(tmpmodel *m, byte r,byte g,byte b,byte alpha,texture *texture1) {
 material *mat=mat_create(r,g,b,alpha,texture1);
 model_face_begin_mat(m,mat);
}

/** prida vertex do modelu (pokud tam uz neni), vrati jeho cislo. Cisla tvori posloupnost, pocinaje nulou */
int model_addvertex(tmpmodel *m,bfloat x1,bfloat y1,bfloat z1,int check_if_already_exist){
 int j,i=m->numvert;
 if (check_if_already_exist) {
  for (j=0;j<i;j++) {//test jestli tam uz vertex neni
   //TODO: tohle chce HODNE zlepsit. staci malo vertexu a uz je to rychlostne v prdcicich, pac je to n^2
   //TODO: pri n vertexech je to n^2, chci n*log n (BVS)
   //TODO: asi by to byl binarni vyhledavaci strom podle x+y+z (nebo x,y,z)
   if (m->v[j].x==x1 && m->v[j].y==y1 && m->v[j].z==z1 ) return j; //recyklace vertexu
  }
 }
 if (i==m->maxvert) {//test velikosti pole 
  m->maxvert*=2;
  m->v=realloc1(m->v,m->maxvert*sizeof(vertex));
 }
 m->v[i].x=x1;//pridani vertexu
 m->v[i].y=y1;
 m->v[i].z=z1;
 m->numvert++;
 return i;
}

/** prida vertex podle cisla - nutno nejdriv pridat vertexu cislo pres model_addvertex */
void model_vertex_num(tmpmodel *m,bfloat tex_x,bfloat tex_y,int vnum) {
 int i=m->numface-1;// aktualni face
 int np=m->numpoint;
 m->f[i].ncoord++; //pocet vertexu v aktualnim facu
 if (np==m->maxpoint) {
  m->maxpoint*=2;
  m->p=realloc1(m->p,m->maxpoint*sizeof(facecoord));
 }
 m->p[np].n=vnum;
 m->p[np].u=tex_x;
 m->p[np].v=tex_y;
 m->numpoint++;
}

/** prida vertex podle souradnic */
void model_vertex(tmpmodel *m,bfloat tex_x,bfloat tex_y,bfloat x,bfloat y,bfloat z) {
 int vnum=model_addvertex(m,x,y,z,0);//TODO: posledni parmetr dat na 1, az to spravim
 model_vertex_num(m,tex_x,tex_y,vnum);
}

/** prida vertex (podle souradnic) */
void model_vertexv(tmpmodel *m,bfloat tex_x,bfloat tex_y,vertex v) {
 int vnum=model_addvertex(m,v.x,v.y,v.z,0);//TODO: posledni parmetr dat na 1, az to spravim
 model_vertex_num(m,tex_x,tex_y,vnum);
}

/** prida vertex (podle souradnic, se scalovanim) */
void model_vertexvs(tmpmodel *m,bfloat tex_x,bfloat tex_y,vertex v,bfloat scale) {
 int vnum=model_addvertex(m,v.x*scale,v.y*scale,v.z*scale,0);//TODO: posledni parmetr dat na 1, az to spravim
 model_vertex_num(m,tex_x,tex_y,vnum);
}

/** konec facu: normala dana vektorem */
void model_face_end_v(tmpmodel *m,vector normal) {
 m->f[m->numface-1].normal=normal;
}

/** konec facu: normala se spocita automaticky*/
void model_face_end(tmpmodel *m) {
 vector normal={0,0,0};
 int i=m->numface-1;// aktualni face
 int nc=m->f[i].ncoord;
 if (nc>2) { //z prvnich 3 vektoru udela normalu
  int np=m->numpoint-nc;
  normal=v_mulv(v_sub(m->v[m->p[np+2].n],m->v[m->p[np+1].n]),v_sub(m->v[m->p[np+1].n],m->v[m->p[np].n]));
  normalize(&normal);
 }
// debug_printf0("model_face_end : normal = %g %g %g\n",all3d(normal));
 model_face_end_v(m,normal);
}

/** nastavi na axis-aligned bounding boxu do souradni + a - nekonecno */
void abox_inf(aa_bbox *b) {
 b->lo.x=b->lo.y=b->lo.z=finf;
 b->hi.x=b->hi.y=b->hi.z=-finf;
}

/** vynujuje axis-aligned bounding box */
void abox_null(aa_bbox *b) {
 zerov(b->lo);
 zerov(b->hi);
}

/** vrati aa-bbox dane velikosti (<-x -x -x> - <+x +x +x>) */
aa_bbox abox_x(bfloat x) {
 aa_bbox b;
 b.lo.x=b.lo.y=b.lo.z=-x;
 b.hi.x=b.hi.y=b.hi.z=x;
 return b;
}

/** prida vertex do bounding boxu */
void abox_addvertex(aa_bbox *a,vertex v) {
 if (v.x>a->hi.x) a->hi.x=v.x;
 if (v.y>a->hi.y) a->hi.y=v.y;
 if (v.z>a->hi.z) a->hi.z=v.z;
 if (v.x<a->lo.x) a->lo.x=v.x;
 if (v.y<a->lo.y) a->lo.y=v.y;
 if (v.z<a->lo.z) a->lo.z=v.z;
}

/** spocita bounding box modelu */
void model_calculate_abox(model3d *mo) {
 int q;
 debug_printf0("Adding %d vertexes to abox\n",mo->nvert);
 if (mo->nvert) {
  abox_inf(&mo->abox);
  for (q=0;q<mo->nvert;q++) { //calculate bounding box
   abox_addvertex(&mo->abox,mo->vert[q]);
  }
 } else {
  abox_null(&mo->abox);
 }
}

/** axis-aligned bounding box je vynasobena o vektor scale */
void abox_scale_v(aa_bbox *a,const vector scale) {
 a->hi.x*=scale.x;
 a->lo.x*=scale.x;
 a->hi.y*=scale.y;
 a->lo.y*=scale.y;
 a->hi.z*=scale.z;
 a->lo.z*=scale.z;
}

/** axis-aligned bounding box je vynasobena o konstantu scale */
void abox_scale(aa_bbox *a,const bfloat scale) {
 a->hi.x*=scale;
 a->lo.x*=scale;
 a->hi.y*=scale;
 a->lo.y*=scale;
 a->hi.z*=scale;
 a->lo.z*=scale;
}

/** axis-aligned bounding box je posunuta o vektor polohy */
void abox_move_v(aa_bbox *a,const vector p) {
 a->hi.x+=p.x;
 a->lo.x+=p.x;
 a->hi.y+=p.y;
 a->lo.y+=p.y;
 a->hi.z+=p.z;
 a->lo.z+=p.z;
}

/** vrati axis-aligned bounding box posunutou o vektor polohy */
aa_bbox abox_move(aa_bbox *a,const vector p) {
 aa_bbox e;
 e.hi.x=a->hi.x+p.x;
 e.lo.x=a->lo.x+p.x;
 e.hi.y=a->hi.y+p.y;
 e.lo.y=a->lo.y+p.y;
 e.hi.z=a->hi.z+p.z;
 e.lo.z=a->lo.z+p.z;
 return e;
}

/** presune vsechny vertexy v modelu o (ix,iy,iz) - move */
void model_move(model3d *mo,bfloat ix,bfloat iy,bfloat iz) {
 int i;
 vector iv;
 for (i=0;i<mo->nvert;i++) {
  mo->vert[i].x+=ix;
  mo->vert[i].y+=iy;
  mo->vert[i].z+=iz;
 }
 iv.x=ix;iv.y=iy;iv.z=iz;
 abox_move_v(&mo->abox,iv);
}

/** vynasobi vsechny vertexy v modelu (ix,iy,iz) - scale */
void model_scale(model3d *mo,bfloat ix,bfloat iy,bfloat iz) {
 int i;
 vector iv;
 for (i=0;i<mo->nvert;i++) {
  mo->vert[i].x*=ix;
  mo->vert[i].y*=iy;
  mo->vert[i].z*=iz;
 }
 iv.x=ix;iv.y=iy;iv.z=iz;
 abox_scale_v(&mo->abox,iv);
}

/** vyrobi finalni 3d model z docasneho modelu */
model3d *model_end(tmpmodel *m) {
 int fi,fo,fpi,fpo,q;
 model3d *mo;//vystupni model
 mo=malloc0(sizeof(model3d));
 //vertexes
 mo->nvert=m->numvert;
 mo->vert=malloc1(mo->nvert*sizeof(vertex));
 memmove(mo->vert,m->v,mo->nvert*sizeof(vertex));
 //face points
 mo->nfacev=m->numpoint;
 mo->facev=malloc1(mo->nfacev*sizeof(facecoord));
 //faces
 mo->nface=m->numface;
 mo->face=malloc1(mo->nface*sizeof(modelface));
// stary kod - netridil na transparentni a netransparentni
// memmove(mo->facev,m->p,mo->nfacev*sizeof(facecoord));
// memmove(mo->face,m->f,mo->nface*sizeof(modelface));

 //move facepoints and faces
 fpo=0;fo=0;
 for (fpi=0,fi=0;fi<m->numface;fi++) {//for each face
  if (m->f[fi].m->color[3]==255) {
   mo->face[fo]=m->f[fi];
   mo->face[fo].m->ref++;//refcount u materialu
   fo++;
   for (q=0;q<m->f[fi].ncoord;q++) {
    mo->facev[fpo+q]=m->p[fpi+q];
   }
   fpo+=m->f[fi].ncoord;
  }
  fpi+=m->f[fi].ncoord;
 }
 debug_printf0("model_end: !pi=%d po=%d\n",fpi,fpo);
 debug_printf0("model_end: !fi=%d fo=%d\n",fi,fo);
 for (fpi=0,fi=0;fi<m->numface;fi++) {//for each face
  if (m->f[fi].m->color[3]!=255) {
   mo->face[fo]=m->f[fi];
   mo->face[fo].m->ref++;//refcount u materialu
   fo++;
   for (q=0;q<m->f[fi].ncoord;q++) {
    mo->facev[fpo+q]=m->p[fpi+q];
   }
   fpo+=m->f[fi].ncoord;
  }
  fpi+=m->f[fi].ncoord;
 }
 debug_printf0("model_end: pi=%d po=%d (%d)\n",fpi,fpo);
 debug_printf0("model_end: fi=%d fo=%d (%d)\n",fi,fo);

 model_calculate_abox(mo);
 //texture list
 mo->matl=dupmatlist(m->matl);
 model_set_materials(mo);
 return mo;
}

//TODO: multithread: behem nahravani modelu (model_begin/model_end) nesmi prijit flush textur ci materialu (zatim to nevadi)

/** vycisti model, ale neuvolni pamet. dobre pokud chcem hned delat dalsi model */
void model_clear(tmpmodel *m) {
 m->numvert=m->numface=m->numpoint=0;
 freematlist(m->matl);
 m->matl=0;
}

/** uvolni model z pameti */
void model_free(tmpmodel *m) {
 model_unset_materials(m);//zlikvidovat materialy
 if (m->matl) freematlist(m->matl);//zlikvidovat material list
 if (m->p) free(m->p);
 if (m->v) free(m->v);
 if (m->f) free(m->f);
 free(m);
}


//MODEL MANAGER

tree *model_tree; // strom s nahranymi modely      [EXT]
model3d *failsafemodel;//model pouzity pokud neni zadany model k dispozici (muze byt i NULL)

/** Nahraje model z disku do pameti, typ modelu se vezme dle pripony */
model *fs_loadmodel(const char *name) {
 model3d *m;
 model *mo;
 char *nameplus;
 char *name2;
 debug_printf("Loading model: %s ->",name);
 name2=str_plus("models/",name);
 debug_printf("%s\n",name2);
 //autodetekce modelu podle extension
 if (str_endwithi(name,".map")) m=model_map_load(name2);
 else if (str_endwithi(name,".txt")) m=model_txt_load(name2);
 else { /// bez extension, zkusi priplacavat ruzne extensions a model nahravat jako ruzne typy
  debug_printf("No ext found: %s\n",name);
  nameplus=str_plus(name2,".txt");
  m=model_txt_load(nameplus);
  str_free(nameplus);
  if (!m) { // mpredchozi ty se nenahral, zkusim dalsi
   nameplus=str_plus(name2,".map");
   m=model_map_load(nameplus);//.map az v nejvyssi nouzi
   str_free(nameplus);
  }
 }
 str_free(name2);
 debug_printf("Model found as: %d\n",m);
 if (!m) m=failsafemodel;
 mo=malloc0(sizeof(model));
 mo->mem=m;
 mo->name=strdup(name);
 return mo;
}

/** Uvolni nahrany model z pameti */
void fs_unloadmodel(model *ou) {
 if (ou->mem!=failsafemodel && ou->mem) {// z failsafe se bere vzdy jen odkaz na pamet.
  ou->mem->manager=0;
  freemodel_real(ou->mem);
 }
 free(ou->name);
 free(ou);
}

/** Nahraje model z v pameti do  model manageru */
model *model_addtomanager(model3d *m,const char *name_as) {
 model *mo;
 if (!m) m=failsafemodel;
 mo=malloc0(sizeof(model));
 mo->mem=m;
 mo->name=strdup(name_as);
 debug_printf0("[ModelMan] model added as '%s'\n",name_as);
 tree_add(&model_tree,name_as,mo);
 m->manager=mo;
 return mo;
}

/**  nahraje model s danym jmenem a zaradi ho do seznamu nahranych modelu
  Pokud je v pameti tak misto nahravani rovnou vrati pointer.
  Muze vratit i null (prazdny model)
*/
model *b_loadmodel_internal(const char *name) {
 model *tg;
 debug_printf("[ModelMan] %s requested\n",name);
 tg=tree_search(model_tree,name);
 if (tg) return tg; //model je jiz v pameti, netreba nahravat
 tg=fs_loadmodel(name);
 debug_printf0("[ModelMan] %s loaded\n",name);
 tree_add(&model_tree,name,tg);
 if (tg->mem) { 
  tg->mem->manager=0;
 }
 return tg;
}

/**  podiva se po modelu s danym jmenem v pameti a pokud tam je, tak ho odstrani*/
void b_unloadmodel(const char *name) {
 model *tg=tree_search(model_tree,name);
 if (!tg) return; //model jiz neni v pameti
 tree_del(&model_tree,name);
 fs_unloadmodel(tg);
}

/** zavola b_loadmodel_internal a zvysi usage counter
*/
model3d *b_loadmodel_r(const char *name) {
 model *r=b_loadmodel_internal(name);
 if (r) {
  r->refcount++;
  if (r->mem) r->mem->manager=r;
 }
 debug_printf0("b_loadmodel_r: return %d\n",r->mem);
 return r->mem;
}

/** quick hack - nahraje model a pak ho scaluje a posunuje - nyni neni pouzivano */
model3d *b_loadmodel_r_trans(const char *name,bfloat tx,bfloat ty,bfloat tz,bfloat sx,bfloat sy,bfloat sz) {
 model3d *r=b_loadmodel_r(name);
 if (r && r->manager && r->manager->refcount==1) {//prave nahrany
  model_move(r,tx,ty,tz);
  model_scale(r,sx,sy,sz);
 }
 return r;
}


/** zavola b_loadmodel_internal a nezvysi usage counter
*/
model3d *b_loadmodel(const char *name) {
 return b_loadmodel_internal(name)->mem;
}

/**  podiva se po modelu s danym jmenem v pameti a pokud tam je, tak ji snizi reference count. Pokud je 0, tak je odstranen z pameti
vraci: 1  - model odstranen
0 - model neni v pameti
 */
int b_unloadmodel_r(const char *name) {
 model *tg=tree_search(model_tree,name);
 if (!tg) {
  debug_printf("unload failed: %s\n",name);
  return 0; //jiz neni v pameti
 }
 tg->refcount--;
 debug_printf("%s ref %d\n",name,tg->refcount);
 if (tg->refcount) return 1;// stale je pouzivan
 tree_del(&model_tree,name);
 debug_printf("unoading %d\n",name,tg->refcount);
 fs_unloadmodel(tg);
 return 1;
}

/** vnitri callback funkce model_flush (pridani do seznamu) */
void _model_flush(char *name,model *t,l_list **l) {
 if (t->refcount<0) {
  fatalf("_model_flush: negative refcount (%s,%d)\n",t->name,t->refcount);
 }
 if (t->refcount) return;
 l_list_add(l,t);
 unused(name);
}

/** odstrani z pameti modely co nejsou pouzivany (refcount=0) */
void model_flush() {
 l_list *t=0,*p;
 tree_foreach_p(model_tree,(tree_func_p *)_model_flush,&t);//nalezeni vsech nepouzitych a pridani do seznamu
 p=t;
 while(p) {//likvidace obsahu seznamu
  debug_printf0("removing %s:%d\n",((model *)(p->t))->name,((model *)(p->t))->refcount);
  b_unloadmodel(((model *)(p->t))->name);
  p=p->next;
 }
 freel_list(t);//likvidace seznamu
}

//TODO: material manager, material list (aby byl prehled o anonymnich materialech)
//TODO: predelat na mnoha mistech textury do materialu

/** nahrani modelu ve formatu milkshapa ascii */
model3d *model_txt_load(const char *name) {
 int len,num_meshes=0,num_vectors,num_tris,num_normals,num_materials=0,i,j,k,mat_i,dummy,vert_offset=0;
 char *data=0,*key=0,*value=0,*cmap=0,*amap=0;
 text_token t,*tp=&t;
 tmpmodel *m=0; 
 model3d *mf=0;
 bfloat *uv=0;//u,v souradnice
 bfloat x,y,z;
 vector *normal=0;//normaly
 int *tri=0;
 material **mats=0;//struktura s ocislovanymi materialy
 texture *tex=0;

 debug_printf0("model_txt_load: loading file %s\n",name);
 len=fs_loadfile((void **)(&data),name);
 if (!data) return 0;
 debug_printf0("model_txt_load: loaded data\n");
 t=token_create(data,len);
 while (token_readkv_sep(tp,&key,&value,':')) {
  if (eqi(key,"meshes")) {
   num_meshes=atoi(value);
   free(key);
   break;//meshes number, ignore rest
  }
  free(key);
 }
 if (num_meshes<1) goto fatal;//soubor je vicemene prazdny
 debug_printf0("model_txt_load: loading mesh(es): %d\n",num_meshes);
 m=model_begin();
 for(j=0;j<num_meshes;j++) {
  debug_printf0("model_txt_load: loading mesh: %d\n",j);
  free(token_readqstring(tp));// mesh: name
  token_readint(tp,&dummy);// flags
  token_readint(tp,&mat_i);// material_index
  //nacteni vertexu
  if (!token_readint(tp,&num_vectors)) goto fatal;//num of vertices
  if (num_vectors<0) goto fatal;
  if (num_vectors==0) { //prazdny objekt - nektere modely ho tam maji - zvlastni ...
   int r= token_readint(tp,&dummy) && (dummy==0);// num normals ()
   r=r && token_readint(tp,&dummy) && (dummy==0);// num faces
   if (r) continue; else goto fatal;
  }
  if (uv) free(uv);
  uv=malloc1(2*sizeof(bfloat)*num_vectors);
  for (i=0;i<num_vectors;i++) { //for each vertex
   if(token_readint(tp,&dummy)//flags
   && token_readfloat(tp,&x)
   && token_readfloat(tp,&y)
   && token_readfloat(tp,&z)
   && token_readfloat(tp,&uv[i*2])
   && token_readfloat(tp,&uv[i*2+1])
   && token_readint(tp,&dummy)//bone index
   ) model_addvertex(m,x,y,z,0); else goto fatal;
  }
  debug_printf0("model_txt_load: vertexes loaded (%d)\n",num_vectors);
  //nacteni normalovych vektoru
  if (!token_readint(tp,&num_normals)) goto fatal;//num of normals
  if (num_normals<1) goto fatal;//zadne normaly
  if (normal) free(normal);
  normal=malloc1(sizeof(vector)*num_normals);
  for (i=0;i<num_normals;i++) { //for each vertex
   if(!token_readplainvector(tp,normal+i)) goto fatal;
  }
  debug_printf0("model_txt_load: normals loaded (%d)\n",num_normals);
  //nacteni trianglu
  if (!token_readint(tp,&num_tris)) goto fatal;//num of tris
  if (num_tris<1) goto fatal;//zadne facy
  if (tri) free(tri);
  tri=malloc1(4*sizeof(int)*num_tris);
  for (i=0;i<num_tris;i++) { //for each tri
   if(token_readint(tp,&dummy)//flags
   && token_readint(tp,&tri[i*4])//vertex index 1
   && token_readint(tp,&tri[i*4+1])//vertex index 2
   && token_readint(tp,&tri[i*4+2])//vertex index 3
   && token_readint(tp,&tri[i*4+3])//normal index 1
   && token_readint(tp,&dummy)//normal index 3
   && token_readint(tp,&dummy)//normal index 2
   && token_readint(tp,&dummy)//smoothing group
   ) {
    for(k=0;k<3;k++) tri[i*4+k]+=vert_offset;// vyssi modely maj vetsi indexy vertexu, nutno premapovat
   } else goto fatal;
  }
  debug_printf0("model_txt_load: loaded tris: %d\n",num_tris);
  //end of reading one mesh, now insert into model
  for (i=0;i<num_tris;i++) { //for each tri (face)
   model_face_begin_mat(m,NULL);//vlozeno bez materialu
   m->f[m->numface-1].m=(material *)mat_i;//takhle natvrdo to tam davam protoze pointery na material jeste nemam. Pozdeji vsechny cisla materialu nahradim spravnymi pointery
   for(k=2;k>=0;k--) { //pridat vertexy 
    int num=tri[i*4+k];
    if (num-vert_offset>=num_vectors || num-vert_offset<0) {
     debug_printf("model_txt_load: bad vertex number: %d at byte offset %d (face %d)\n",num,t.curr-t.begin,i);
     goto fatal;
    }
    model_vertex_num(m,uv[(num-vert_offset)*2],uv[(num-vert_offset)*2+1],num);
   }
   if (tri[i*4+3]>=num_normals || tri[i*4+3]<0) {
    debug_printf("model_txt_load: bad normal number: %d at byte offset %d (face %d)\n",tri[i*4+3],t.curr-t.begin,i);
    goto fatal;
   }
   model_face_end_v(m,normal[tri[i*4+3]]);
  }  
  vert_offset+=num_vectors;
 } //end of reading meshes 
 debug_printf0("model_txt_load: going to load materials\n",num_materials);
 while (token_readkv_sep(tp,&key,&value,':')) {
  if (eqi(key,"materials")) {
   num_materials=atoi(value);
   free(key);
   break;//materials number, ignore rest
  }
  free(key);
 }
 if (num_materials<1) goto fatal;//nejsou materialy! mozna by to slo resit jinak, ale stejne je to vadny soubor, takze co ....
 debug_printf0("model_txt_load: loading material(s): %d\n",num_materials);
 mats=malloc1(sizeof(material)*num_materials);
 for (j=0;j<num_materials;j++) {
  vector ambient,diffuse,specular,emissive;
  bfloat ambient_a,diffuse_a,specular_a,emissive_a,shiny,alpha;
  int r;
  if ((key=token_readqstring(tp))==NULL) goto fatal;
     r=token_readplainvector(tp,&ambient);
  r=r && token_readfloat(tp,&ambient_a);
  r=r && token_readplainvector(tp,&diffuse);
  r=r && token_readfloat(tp,&diffuse_a);
  r=r && token_readplainvector(tp,&specular);
  r=r && token_readfloat(tp,&specular_a);
  r=r && token_readplainvector(tp,&emissive);
  r=r && token_readfloat(tp,&emissive_a);
  r=r && token_readfloat(tp,&shiny);
  r=r && token_readfloat(tp,&alpha);
  if (!r) {
   free(key);
   goto fatal;
  }
  if ((cmap=token_readqstring(tp))==NULL) goto fatal;
  if ((amap=token_readqstring(tp))==NULL) goto fatal;
  if (!cmap || !cmap[0]) tex=0; else tex=b_loadtexture(cmap);
  mats[j]=mat_create((byte)(diffuse.x*255),(byte)(diffuse.y*255),(byte)(diffuse.z*255),(byte)(alpha*255),tex);
#define setv3(_x,_y) _x[0]=(_y).x;_x[1]=(_y).y;_x[2]=(_y).z
  setv3(mats[j]->emission,emissive);
  setv3(mats[j]->ambient,ambient);
  setv3(mats[j]->diffuse,diffuse);
  setv3(mats[j]->specular,specular);
  mats[j]->shininess=shiny;
  mats[j]->ref=1;
  mats[j]->name=key;//nemusi to tu bejt, navic nazev nebude asi unikatni
  debug_printf("Material: %d: mat=%s, tex=%s rgba=%d %d %d %d\n",j,mats[j]->name,(mats[j]->tex)?mats[j]->tex->name:"--",mats[j]->color[0],mats[j]->color[1],mats[j]->color[2],mats[j]->color[3]);
  free(cmap);cmap=0;
  free(amap);amap=0;
 }
 debug_printf0("model_txt_load: %d materials loaded\n",num_materials);
 for (j=0;j<m->numface;j++) { // v kazdem facu replacnout material
  if ((int)m->f[j].m>=num_materials || (int)m->f[j].m<0) {
   debug_printf("model_txt_load: bad material number: %d > %d at byte offset %d (face %d)\n",(int)m->f[j].m,num_materials,t.curr-t.begin,j);
   goto fatal;
  }
  m->f[j].m=mats[(int)m->f[j].m];
  model_material_used(m,m->f[j].m);//prekonvertovany material pridat
 }
 mf=model_end(m);
 debug_printf0("model_txt_load: success\n");
 for (j=0;j<num_materials;j++) {// free unnecessary materials
  mat_free(mats[j]);//ty co mas refcount>1 (jsou pouzity) tak preziji, zbytek jde pryc
 } 
 free(mats);
 debug_printf0("model_txt_load: freed materials\n");
fatal:
 if (cmap) free(cmap);
 if (amap) free(amap);
 if (tri) free(tri);
 if (data) free(data);
 if (m) model_free(m);
 if (uv) free(uv);
 if (normal) free(normal);
 return mf;
}

//TODO: map_model object

/*
nevyhody: v pameti je jak original, tak modifikovana kopie (ale pri flushi original zmizi, pokud je jinde nepouzivan)
*//*
model3d *mdef_load(const char *name) {
 nahraj .mdef soubor
 nahraj original model
 aplikuj transformace
 soupni do cache
 odehraj original model (sniz refcount)
}
*/

/*
mdef file

model={model-name.ext} //can't be another mdef
scale=1 1 1
translate=0 0 0
rotate=0 0 0
*/

@


1.4
log
@*** empty log message ***
@
text
@d9 1
d11 1
a127 1
  debug_printf0("freemodel:use manager, refcount=%d\n",m->manager->refcount);
d129 1
a129 1
   debug_printf("freemodel: null model name in manager!!! BUG!!!\n");
d131 2
a132 1
   //TODO: tohle bude v budoucnu celkem chyba!!!!
d134 1
d138 2
a139 2
 //TODO: nesnazit se o dealokaci tady, ale pozdeji udelat flush
 freemodel_real(m);
d156 1
d168 1
d172 1
d590 13
d607 1
a607 1
model *b_loadmodel_internal(char *name) {
d622 1
a622 1
void b_unloadmodel(char *name) {
d631 1
a631 1
model3d *b_loadmodel_r(char *name) {
d642 1
a642 1
model3d *b_loadmodel_r_trans(char *name,bfloat tx,bfloat ty,bfloat tz,bfloat sx,bfloat sy,bfloat sz) {
d654 1
a654 1
model3d *b_loadmodel(char *name) {
d658 5
a662 2
/**  podiva se po modelu s danym jmenem v pameti a pokud tam je, tak ji snizi reference count. Pokud je 0, tak je odstranen z pameti */
void b_unloadmodel_r(char *name) {
d664 4
a667 1
 if (!tg) return; //jiz neni v pameti
d669 2
a670 1
 if (tg->refcount) return;// stale je pouzivan
d672 1
d674 1
@


1.3
log
@*** empty log message ***
@
text
@d160 1
a160 1
#ifdef use_odelib
@


1.2
log
@*** empty log message ***
@
text
@a11 3
//forward
void world_destroyobject(object3d *o);

a119 2
void b_unloadmodel_r(char *name);//forward

a139 2
void freeobject(object3d *o);//forward definice

a540 2

model3d *model_map_load(const char *name);//forward
@


1.1
log
@Initial revision
@
text
@d671 1
a671 1
 tree_foreach_p(model_tree,_model_flush,&t);//nalezeni vsech nepouzitych a pridani do seznamu
d699 1
a699 1
 len=fs_loadfile(&data,name);
@
