head	1.7;
access;
symbols;
locks
	bilbo:1.7; strict;
comment	@ * @;


1.7
date	2003.09.10.18.08.33;	author bilbo;	state Exp;
branches;
next	1.6;

1.6
date	2003.06.08.17.17.32;	author bilbo;	state Exp;
branches;
next	1.5;

1.5
date	2003.06.08.14.34.31;	author bilbo;	state Exp;
branches;
next	1.4;

1.4
date	2003.06.07.10.42.50;	author bilbo;	state Exp;
branches;
next	1.3;

1.3
date	2003.05.31.01.25.57;	author bilbo;	state Exp;
branches;
next	1.2;

1.2
date	2003.05.22.13.10.00;	author bilbo;	state Exp;
branches;
next	1.1;

1.1
date	2003.05.22.10.26.05;	author bilbo;	state Exp;
branches;
next	;


desc
@@


1.7
log
@*** empty log message ***
@
text
@/***
 ruzne funkce:

 prace s binarnimi vyhledavacimi stromy
 prace s tokeny
 + dalsi
*/
#include "b_util.h"
#include "bilbo.h"
#include "b_mem.h"
#include "b_string.h"

char _statx[40];//buffer na formatovane datum (btime)

/** naformatuje datum do stringu. Nelze pouzivat multithreaded */
char *btime(const struct tm* t) {
 (void)strftime((char *)&_statx,sizeof(_statx),"%d.%m.%y %H:%M",t);
 return _statx;
}

/** vypise retezec a odradkuje */
void writeln(char *s) {
 printf("%s\n",s);
}

/** vyskoci s chybovou hlaskou. Dobre k debugovani */
void fatal(char *s){
 writeln(s);
 #ifdef WIN32
 #ifndef only_console
 MessageBox(0,s,"Fatal error",MB_ICONEXCLAMATION);
 #endif
 #endif
 exit(EXIT_FAILURE);
}

/** jako fatal(), ale s formatovanym retezcem jako u printf */
void fatalf(char *fmt,...){
 va_list argptr;
 char s[256];
 va_start(argptr,fmt);	
 _vsnprintf(s,sizeof(s),fmt,argptr);
 va_end(argptr);
 fatal(s);
}

/** vrati pocet milisekund od startu */
uint gettickcount(void) {
 //TODO: pouzit neco s vetsi presnosti
 return glutGet(GLUT_ELAPSED_TIME);
}

/** odalokuje strom z pameti */
void tree_free(tree *t) {
 if (!t) return;
 tree_free(t->r);
 tree_free(t->l);
 free(t->name);
 free(t);
}

/** zduplikuje dany strom - vytvori novou kopii */
tree *tree_dup(const tree *t) {
 tree *nt=0;
 if (!t) return 0;
 tree_add(&nt,t->name,t->val);
 nt->num=t->num;
 nt->l=tree_dup(t->l);
 nt->r=tree_dup(t->r);
 return nt;
}

/** vytahne ze stromu ukazatel na list s prvek s cislem i (i je mezi 0 a (poctem prvku ve stromu -1)
Da se pouzit napr. pro prochazeni cleeho stropu, ackoliv tree_foreach / tree_foreach_p muze byt vhodnejsi
Pokud nastane chyba nebo je prvek mimo rozsah, vrati NULL
 */
const tree *tree_element(const tree *t,int i) {
 if (!t) return 0;
 if (i==0) return t;//nasli jsme!
 if (i>=t->num) return 0;//tolik prvku ve strome neni
 if (!t->l) return tree_element(t->r,i-1);
 if (i<=t->l->num) {//je to v leve casti
  return tree_element(t->l,i-1);
 } else { //je to v prave casti (nebo mimo)
  return tree_element(t->r,i-1-t->l->num);
 }
}

/** prohleda strom jestli obsahuje polozku name a vrati ji, pokud neobsahuje, vraci 0 */
void *tree_search(const tree *t,const char *name) {
 int r;
 if (!t) return 0;
 r=stricmp(name,t->name);
 if (r>0) return tree_search(t->l,name);
 if (r<0) return tree_search(t->r,name);
 return t->val;
}

/** prida do stromu polozku se jmenem name a hodnovou val1, pokud je jiz obsazena, neprida nic (a pokud je zapnuty debug tak rovnou fatalne spadne) */
void tree_add(tree **t,const char *name,void *val1) {
 int r;
 if (!*t) {//root==null
  *t=(tree *)malloc0(sizeof(tree));
 } else { //left or right
  r=stricmp((*t)->name,name);
  (*t)->num++;
  if (r<0) {
   tree_add(&((*t)->l),name,val1);
   return;
  }
  if (r>0){
   tree_add(&((*t)->r),name,val1);
   return;
  }
 #ifdef vdebug
  fatalf("assert: tree_add (%s): already present",name);
 #endif
  return;
 }
 (*t)->num++;
 (*t)->name=strdup(name);
 (*t)->val=val1;
}

/** vyvazi strom */
void tree_optimize(tree **t) {
//TODO: vyvazit strom. Mozna ani nebude treba (pouziji se AVL stromy)
 unused(t);
}

/** zavola funkci na kazdy prvek stromu */
void tree_foreach(tree *t,tree_func *f) {
 if (!t) return;
 tree_foreach(t->r,f);
 f(t->name,t->val);
 tree_foreach(t->l,f);
}

/** zavola funkci na kazdy prvek stromu (s extra parametrem)*/
void tree_foreach_p(tree *t,tree_func_p *f,void *param) {
 if (!t) return;
 tree_foreach_p(t->r,f,param);
 f(t->name,t->val,param);
 tree_foreach_p(t->l,f,param);
}

/** odstrani ze stormu polozku name
 1 - polozka byla odstranena
 0 - polozka tam nebyla
 */
int tree_del(tree **t,const char *name) {
 int r;
 //TODO: updatovat t->num (pocet prvku stromu)
 tree *op,*op2,*op3;
 if (!*t) return 0;//neni co mazat
 r=stricmp((*t)->name,name);
 if (r<0) {
  return tree_del(&((*t)->l),name);
 }
 if (r>0) {
  return tree_del(&((*t)->r),name);;
 }
 //trefa!
 op=*t;
 if (!op->l) {
  *t=op->r;
 } else if (!op->r) {
  *t=op->l;
 } else {//oba podstromy.
  //TODO: zavesit tu mensi cast pod vetsi (bude mensi hloubka stromu)
  *t=op->r;
  op3=op->l;//druha cast stromu
  op2=op->r;//sem ji chci zavesi
  while (op2->l) op2=op2->l;
  op2->l=op3;
 }
 free(op->name);
 free(op);
 return 1;
}

/** odstrani ze stormu polozku name a vrati ji (nebo NULL, pokud tam neni)
 1 - polozka byla odstranena
 0 - polozka tam nebyla
 */
void *tree_delv(tree **t,const char *name) {
 int r;
 tree *op,*op2,*op3;
 void *o;
 if (!*t) return 0;//neni co mazat
 r=stricmp((*t)->name,name);
 if (r<0) {
  return tree_delv(&((*t)->l),name);
 }
 if (r>0) {
  return tree_delv(&((*t)->r),name);;
 }
 //trefa!
 op=*t;
 if (!op->l) {
  *t=op->r;
 } else if (!op->r) {
  *t=op->l;
 } else {//oba podstromy.
  *t=op->r;
  op2=op->r->l;
  op3=op->l;
  op->r->l=op3;
  while (op3->r) op3=op3->r;
  op2=op3->r;
 }
 free(op->name);
 o=op->val;
 free(op);
 return o;
}

/** vrati pocet prvku stromu */
int tree_count(tree *t) {
 if (t) return t->num;
 return 0;
}

// funkce na praci s textovymi tokeny

/** preskoci vse v tokenu az do konce radky */
void token_remove_rest_of_line(text_token *t) {
 while (t->left && !newline(t->curr[0])) {
  token_move(t,1);
 }
}

/** preskoci vsechny whitespacy a pokud narazi na komentar, tak i ten */
void token_skip_trash(text_token *t) {
 while (t->left) {// je li neco v bufferu
  while (token_whitespace(t)) {//skip whitespace
   token_move(t,1);
  }
  if (t->left>=2) {
   if (t->curr[0]==t->curr[1] && t->curr[1]=='/') {
    token_remove_rest_of_line(t);
    continue;// za komentarem muze byt nekolik newlinu
   }
  }
  return;
 }
}

/** nacte znak z tokenu a odstrani ho. Vraci 1 pri uspechu, 0 pri chybe (je tam jiny znak, nebo tam neni zadny) */
int token_readchar(text_token *t,char c) {
 token_skip_trash(t);
 if (token_beginwith(t,c)) {
  token_move(t,1);
  return 1;
 }
 return 0;
}

/** nacte retezec v uvozovkach z tokenu */
char *token_readqstring(text_token *t) {
 char *begin,*ret;
 int len;
 token_skip_trash(t);
 token_readchar(t,'"');
 begin=t->curr;
 while (!token_beginwith(t,'"')) {
  if (t->left==0) return 0;// chyba, neukonceny retezec
  token_move(t,1);
 }
 len=t->curr-begin;
 ret=malloc1(len+1);
 b_strncpy(ret,begin,len+1);
 token_readchar(t,'"');
 return ret;
}

/** nacte z tokenu binarni integer */
int token_loadintb(text_token *t,int *i) {
 if (t->left<sizeof(int)) return 0;// chyba, malo znaku
 *i=*(int *)(t->curr);
 token_move(t,sizeof(int));
 return 1;
}

/** nacte z tokenu kus binarnich dat */
int token_loadbinary(text_token *t,void *i,int s) {
 if (t->left<s) return 0;// chyba, malo znaku
 memmove(i,t->curr,s);
 token_move(t,s);
 return 1;
}

/** nacte z tokenu vektor (binarni) */
int token_loadvectorb(text_token *t,vector *v) {
 return token_loadbinary(t,v,sizeof(vector));
}

/** nacte z tokenu float (binarni) */
int token_loadfloatb(text_token *t,bfloat *v) {
 return token_loadbinary(t,v,sizeof(bfloat));
}

/** nahraje retezec (delka+znaky) z tokenu */
int token_loadlstring(text_token *t,char **c) {
 int l;
 *c=0;
 if (!token_loadintb(t,&l)) return 0;
 if (l<0) return 1;//terminator - NULL pointer
 *c=malloc1(l+1);
 (*c)[l]=0;
 if (!token_loadbinary(t,*c,l)) {
  free(*c);
  *c=0;
  return 0;
 }
 return 1;
}

/** nacte retezec z tokenu (znaky az do prvni whitespace nebo konce radky) */
char *token_readstring(text_token *t) {
 char *begin,*ret;
 int len;
 token_skip_trash(t);
 begin=t->curr;
 while (!token_whitespace(t)) {
  if (t->left==0) return 0;// chyba, neukonceny retezec
  token_move(t,1);
 }
 len=t->curr-begin;
 ret=malloc1(len+1);
 b_strncpy(ret,begin,len+1);
 return ret;
}


/** ze zacatku tokenu nacte a odstrani zaznam ve formatu "key" "value" */ 
properties *token_readprop(text_token *t) {
 properties *p;
 token_skip_trash(t);
 if (!token_beginwith(t,'"')) return 0;//zadne property
 p=malloc0(sizeof(properties));
 p->k=strdup(token_readqstring(t));
 p->v=strdup(token_readqstring(t));
 if (!(p->k[0] && p->v)) {
  if (p->v) free(p->v);
  free(p);
  return 0;
 }
 return p;
}

/** ze zacatku tokenu nacte a odstrani zaznam ve formatu key=value.
 Misto = lze pouzit i jiny separator
 POZOR! dealokovat se musi jenom key, nikdy ne value, nebot to je jeden buffer */ 
int token_readkv_sep(text_token *t,char **key,char **value,char separator) {
 char *line,*k,*l;
 for (;;) { //cte tak dlouho dokud nenacte platnou radku, nebo nedojde na konec tokenu
  line=token_readline(t);
  if (!line) return 0;
  debug_printf0("TOKEN_LINE:%s\n",line);
  *key=line;
  k=strchr(line,separator);
  if (k) {
   *k=0;
   l=k+1;
   while (k>*key && isseparator(k[-1])) {//odstran whitespace pred =
    k--;
    *k=0;
   }
   while (isseparator(*l)) l++;//whitespace za =
   *value=l;
   return 1;
  }
  free(line);
  debug_printf0("..was bad\n");
 }
}

/** nacte z tokenu jeden float */
int token_readfloat(text_token *t,bfloat *f) {
 char *s;
 token_skip_trash(t);
 s=token_readstring(t);
 if (!s) return 0;
 *f=atof(s);
 free(s);
 return 1;
}

/** nacte z tokenu jeden integer */
int token_readint(text_token *t,int *i) {
 bfloat f;
 int r=token_readfloat(t,&f);
 *i=(int)floor(f);
 return r;
}

/** nacte z tokenu jeden vektor, format "(x y z)" */
int token_readvector(text_token *t,vector *v) {
 int r= token_readchar(t,'(');
 r=r && token_readfloat(t,&(v->x));
 r=r && token_readfloat(t,&(v->y));
 r=r && token_readfloat(t,&(v->z));
 r=r && token_readchar(t,')');
 return r;
}

/** nacte z tokenu jeden vektor, format "x y z" */
int token_readplainvector(text_token *t,vector *v) {
 int r= token_readfloat(t,&(v->x));
 r=r && token_readfloat(t,&(v->y));
 r=r && token_readfloat(t,&(v->z));
 return r;
}

/** uvolni token z pameti, vcetne jeho vnitrku, tedy dat, ze kterych byl token vytvoren */
void freetoken(text_token *t) {
 free(t->begin);
 free(t);
}

/** nacte z tokenu jednu neprazdnou radku */
char *token_readline(text_token *t) {
 int i=0;
 char *ret;
 token_skip_trash(t);
 if (!t->left) return 0;
 while (t->left && !eol(t->curr[i])) {
  if (t->curr[i]=='/' && t->curr[i+1]=='/') break;
  t->left--;
  i++;
 }
 ret=malloc1(i+1);
 memmove(ret,t->curr,i);
 ret[i]=0;
 t->curr+=i;
 if (t->curr[0]=='/' && t->curr[1]=='/') token_remove_rest_of_line(t);//komentar
 while (t->left && eol(t->curr[0])) {//odstranit konec radku, preskocit pripadne prazdne radky
  t->left--;
  t->curr++;
 }
 return ret;
}

/** vytvori z danych dat parsovatelny token */
text_token token_create(void *source,int size) {
 text_token x;
 x.curr=x.begin=source;
 x.left=size;
 return x;
}
@


1.6
log
@*** empty log message ***
@
text
@d48 1
a48 1
int gettickcount(void) {
@


1.5
log
@*** empty log message ***
@
text
@d9 3
d49 1
@


1.4
log
@*** empty log message ***
@
text
@d49 36
a142 9
/** odalokuje strom z pameti */
void tree_free(tree *t) {
 if (!t) return;
 tree_free(t->r);
 tree_free(t->l);
 free(t->name);
 free(t);
}

d412 1
a412 1
/** uvolni token z pameti */
@


1.3
log
@*** empty log message ***
@
text
@d63 1
a63 1
  *t=malloc0(sizeof(tree));
d105 9
@


1.2
log
@*** empty log message ***
@
text
@a90 2
typedef void tree_func(char *name,void *s);

a97 2

typedef void tree_func_p(char *name,void *s,void *param);
@


1.1
log
@Initial revision
@
text
@d315 101
@
