/*** Automatically generated file from b_ai.h.h and b_ai.c.
Do not modify, modify original files instead */
#ifndef __B_AI_H__ //include only once
#define __B_AI_H__
#include "bilbo.h"
#include "b_config.h"
#include "b_types.h"
#include "b_gl.h"
#include "b_util.h"
#include "b_math.h"
#include "b_world.h"
#include "b_con.h"
#include "b_sound.h"
#include "b_coll.h"

#define ground_fade 0.8f           // rychlost zpomalovani - na zemi
#define air_fade 0.95f             // rychlost zpomalovani - ve vzduchu

#define AI_TIMER object3d *self, int alive_time, int time //hlavicka move funkce, vola se pred kazdym pohybem, parametrem je cas od vytvoreni objektu a cas od posledniho zavolani
#define AI_TOUCH object3d *self,vector touch_point,vector touch_slide, vector touch_push,object3d *target //hlavicka touch funkce, vola se pred kolizi, dostane jako parametry bod kolize, vektor slide a vektor prurazu a dotknuty objekt
#define AI_CREATE object3d *self //hlavicka create funkce, vola se pri objeveni objektu
#define AI_DAMAGE object3d *self,bfloat damage,damage_type damtype,vector offset, object3d *attacker //hlavicka damage funkce, (damage, typ damage, vektor odkud damage prisel (relativni vzhledem k pozici))
#define AI_DESTROY object3d *self //hlavicka destroy funkce, vola se pri zniceni objektu

#define ai_call(FUNCTYPE,obj,TYPE) ((FUNCTYPE *)((obj)->type->ai[TYPE]))//shortcut na volani objekt funkce

typedef enum {//vysledek volani objekt funkce
 ai_none,//funkce neexistuje - nic nezavolano
 ai_ok,//funkce zavolana
 ai_error,//nefatalni chyba
 ai_fatal,//je fatalni chyba
} ai_result;

typedef enum { //damage type
 damage_unknown,//unknown
 damage_crush,//crush/hit
 damage_fire,//fire
 damage_explosion,//explosion
} damage_type;

typedef struct { //list stromu s objekt funkcemi
 ai_func_type type;//typ funkce
 aifunc *func;//funkce
} ai_leaf;

#include "b_ai_int.h" //automaticky generovana cast

/*** 
specificke funkce objektu a sveta
*/
extern worldspawn *world;// Cely svet. Obsahuje vsechny objektu a polygony a vsechno co je prave ve hre 
extern model3d *explosion_model;//jakysi defaultni model na exploze 
extern tree *ai_tree;//strom s objekt funkcemi 
/** nastavi objektu typ a zavola kontruktor classy */
void class_set(object3d *o,const char *name);
/** zkontroluje jestli lze zavolat objekt funkci (jestli je nastavena) */
int ai_call_check(object3d *obj,ai_func_type func);
/** zaregistruje jednu objekt funkci*/
void ai_register_func(const char *name,aifunc *func,ai_func_type type);
/** Spocita vzdalenost daneho bodu od daneho bounding boxu*/
vector abox_distance(vector from, aa_bbox *a);
/** spocte vzdalenost od objektu, bere v uvahu i bounding box a tak ... (ne jenom stred objektu) a vrati ji jako vektor*/
vector world_distance_v(object3d *o,vector from);
/** spocte vzdalenost od objektu, bere v uvahu i bounding box a tak ... (ne jenom stred objektu) a vrati ji jako cislo */
bfloat world_distance(object3d *o,vector from);
/** zpusobi area damage o hodnote damage, vzdalenosti range, typ damage je dtype a pocatek je v origin.
 source je objekt, kteremu se pripise bod za pripadny kill */
void aic_areadamage(object3d *source,bfloat damage,bfloat range,damage_type dtype,vector origin);
/** vytahne z classy hodnotu name (hleda v properties) a vrati ji jako string */
char *aic_getprop(object3d *self,const char *name);
/** vytahne z classy hodnotu name (hleda v properties) a vrati ji jako bfloat */
bfloat aic_getpropf(object3d *self,const char *name);
/** vytahne z classy hodnotu name (hleda v properties) a vrati ji jako bfloat,
 pokud neexistuje, tak vrati defvalue (defaultni hodnotu) */
bfloat aic_getpropfd(object3d *self,const char *name,bfloat defvalue);
/** vytahne z classy hodnotu name (hleda v properties) a vrati ji jako int,
 pokud neexistuje, tak vrati defvalue (defaultni hodnotu) */
int aic_getpropid(object3d *self,const char *name,int defvalue);
/** prida do classy hodnotu key=value */
void aic_addprop(object3d *self,const char *key,const char *value);
/** zpusobi zanik objektu */
void aic_destroyobject(object3d *who);
/** zpusobi zanik objektu BEZ volani destruktoru.
 Napriklad pokud se objekt v konstruktoru rozhodne, ze se ani nechce vytvorit
 a jeho destruktor obsahuje nezadouci efekty (gibs, blood, atd ...)*/
void aic_removeobject(object3d *who);
/** pohyb (teleso typu "kus sutru" bez pohonneho systemu - krome gravitace :o) */
void aic_standard_movement(object3d *who,int ticks);
/** pohyb (teleso typu hrac, neletajici) */
void aic_player_movement(object3d *who,int ticks);
/** zmeni tridu z jednoho objektu na jiny.
 Destruktor stareho se nevola, konstruktor noveho ano */
void aic_recast(object3d *who,const char *name);
/** prehraje zvuk, vychazejici z daneho objektu, variability je mezi 0 a 0.5, urcuje promenslivost vysky zvuku */
void aic_playsound(object3d *o,const char *name,bfloat variability);
/** vytvori na dane pozici novy objekt daneho classname */
object3d *aic_createobject(vector origin,const char *classname);
/** da objektu nahodnou rychlost/rotaci.. udela z nej letici srapnel/gib */
void ai_dogib(object3d *o);
/** objekt (ze) se rozpadne na jednotliv cihliky */
ai_result wall_destroy(AI_DESTROY);
/** na timer nijak nereaguje (dummy funkce) */
ai_result timer_nothing(AI_TIMER);
/** na dotyk nereaguje (dummy funkce) */
ai_result touch_nothing(AI_TOUCH);
/** przdn konstruktor */
ai_result create_nothing(AI_CREATE);
/** konstruktor exploze - nastav model na model exploze */
ai_result create_explosion(AI_CREATE);
/** Konstruktor zdi. Pokud je nastaveno appearance, je to pravdpodobnost v procentech, e ze bude vytvoena (default je 100) */
ai_result create_wall(AI_CREATE);
/** Konstruktor mapobjektu - nezniiteln objekt v map s danm modelem. Stejn jako u zdi, i zde je brna v vahu vlastnost appearance */
ai_result create_mapobject(AI_CREATE);
/** na pokozen nereaguje (tedy nezniiteln objekt) */
ai_result damage_nothing(AI_DAMAGE);
/** pi pokozen sn zdrav (health) objektu (standardn chovn), pokud klesne pod nulu, zavol destruktor */
ai_result damage_normal(AI_DAMAGE);
/** funkce pro pokozen hre, pokud klesne zdrav (health) pod nulu, je hr zabit a tonkovi pipsn bod */
ai_result damage_player(AI_DAMAGE);
/** Pokozen pro objekty, co jsou pi explozi odmrtny dle */
ai_result damage_pushable(AI_DAMAGE);
/** Defaultn destruktor - neudl nic (a objekt je pak znien) */
ai_result destroy_nothing(AI_DESTROY);
/** Dotyk: objekt se sm zni (pouv se u bomb, kde znien obvykle vyvol explozi) */
ai_result touch_bomb(AI_TOUCH);
/** Pokozen: objekt se sm zni (pouv se u bomb, kde znien obvykle vyvol explozi) */
ai_result damage_bomb(AI_DAMAGE);
/** zkonvertuje float na string */
char *ftoa(bfloat x);
/** Znien bomby zpsob explozi (ve vlastnostech bomby lze nastavit slu a dosah - damage a range) */
ai_result destroy_bomb(AI_DESTROY);
/** timer funkce bomby - po danm ase exploduje */
ai_result timer_bomb(AI_TIMER);
/** timer funkce exploze - zajist grafick zobrazen vbuchu (pokozen se udluje jinde) */
ai_result timer_explosion(AI_TIMER);
/** po danm ase zane objekt plunyle mizet */
ai_result timer_fade(AI_TIMER);
/** Timer: objekt se nepohybuje vlastn vl, ale je strkn, i pad */
ai_result timer_stone(AI_TIMER);
/** timer: pohyb hre */
ai_result timer_player(AI_TIMER);
/** k dane classe priradi danou funkco pro dany typ */
void ai_assign(objectclass *c,const char *name,ai_func_type type);
#endif // of __B_AI_H__
