/***
 collision_detection (no ODE) 
 +bounding box calculations
*/

#include "b_coll.h"
//TODO: pri vyssich frameratech casto objekty visi ve vzduchu. To by melo s pouzitim ODe snad zmizet ....

//cheaty (debug)
int flymode=0;                     //ignoruje fakt, ze neni na zemi [EXT]
int noclip=0;                      //ignoruje kolize [EXT]

bfloat move_speed=(1-ground_fade)*64*1.1;      // rychlost pohybu (cca 1.1 ctverecku za cca sekundu) [EXT]
bfloat move_airspeed=(1-ground_fade)*64*0.2;   // rychlost pohybu ve vzduchu [EXT]

extern client **vplayer;

/** maximum z 0,a,b,c,a+b,a+c,b+c,a+b+c - nejvetsi vrchol krychle */
bfloat max_box(bfloat a,bfloat b,bfloat c) {
 bfloat result=0;
 if (a>0) result=a;
 if (b>0) result=result+b;
 if (c>0) result=result+c;
 return result;
}

/** minimum z 0,a,b,c,a+b,a+c,b+c,a+b+c - nejmensi vrchol krychle */
bfloat min_box(bfloat a,bfloat b,bfloat c) {
 bfloat result=0;
 if (a<0) result=a;
 if (b<0) result=result+b;
 if (c<0) result=result+c;
 return result;
}

/** prevede orientovanou bounding-box na axis-aligned bounding-box */
void aa_box(aa_bbox *result,bbox b) {
 vector minus;
 minus.x=min_box(b.dx.x,b.dy.x,b.dz.x);
 minus.y=min_box(b.dx.y,b.dy.y,b.dz.y);
 minus.z=min_box(b.dx.z,b.dy.z,b.dz.z);
 v_sum2(&result->lo,b.org,minus);
 result->hi.x=result->lo.x+max_box(b.dx.x,b.dy.x,b.dz.x)-minus.x;
 result->hi.y=result->lo.y+max_box(b.dx.y,b.dy.y,b.dz.y)-minus.y;
 result->hi.z=result->lo.z+max_box(b.dx.z,b.dy.z,b.dz.z)-minus.z;
}

/** axis-aligned bounding box je zvetsena o vektor pohybu */
void abox_enlarge(aa_bbox *a,const vector m) {
 if (m.x>=0) a->hi.x+=m.x; else a->lo.x+=m.x;
 if (m.y>=0) a->hi.y+=m.y; else a->lo.y+=m.y;
 if (m.z>=0) a->hi.z+=m.z; else a->lo.z+=m.z;
}

/** test jestli se dve bounding boxy prekryvaji */
int abox_intersect(const aa_bbox a,const aa_bbox b) {
 if (a.lo.x<b.lo.x) {
  if (a.hi.x<=b.lo.x) return false;
 } else {
  if (a.lo.x>=b.hi.x) return false;
 }
 if (a.lo.y<b.lo.y) {
  if (a.hi.y<=b.lo.y) return false;
 } else {
  if (a.lo.y>=b.hi.y) return false;
 }
 if (a.lo.z<b.lo.z) {
  if (a.hi.z<=b.lo.z) return false;
 } else {
  if (a.lo.z>=b.hi.z) return false;
 }
 return true;
}

/*int adjust_collision(const bbox obj,const bbox fixed,vector *mov) {//vraci true pokud doslo k narazu
 aa_bbox a_obj,a_eobj,a_fixed;
 aa_box(&a_obj,obj);
 aa_box(&a_fixed,fixed);
 aa_enlarge(&a_eobj,&a_obj,*mov);
 debug_box=obj;
 debug_abox=a_eobj;
 if (intersect(a_eobj,a_fixed)) {
  v_mul(mov,0.8);
  sprintf(info,"%s*",info);
  //TODO: pokud si bounding boxy v pohybu vadi, zmenit vektor mov
  return true;
 }
 return false;
}*/

/** vrati axis-aligned bounding box daneho objektu
 pokud je is_moved!=0, tak vrati bounding box posunuty o pozici objektu
 */
aa_bbox object_abox(object3d *o,int is_moved) {
 aa_bbox ab;
 if (o->abox) { //primo tahle konkretni instance objektu ma nejaky abox
  if (is_moved) return abox_move(o->abox,o->p);
  return *o->abox;
 }
 if (o->type && o->type->abox) { //primo v typu to ma nejaky abox
  if (is_moved) return abox_move(o->type->abox,o->p);
  return *o->type->abox;
 }
 if (o->model) ab=o->model->abox;//ma modell - vezme se bbox z nej
 else if (o->type && o->type->model) ab=o->type->model->abox;
 else {
  debug_printf0("object_abox: No model, no bbox! def. used (%s)\n",classname(o));//tohle kdyz se stane tak obvykle chybi model (chyba v datech)
  return abox_x(16);//defaultni 16kovy bbox
 }
//#ifndef oldcode
 if (o->f.modelscale!=0 && o->f.modelscale!=1) {
  abox_scale(&ab,o->f.modelscale);
 }
//#endif
 if (is_moved) return abox_move(&ab,o->p);
 return ab;
}

#define planevector(N) vert[(facev+N)->n]//Nty vertex aktualniho facu (v collision3d)

int indexes [6/*BOX*/][4/*NUM*/][3/*coord x,y,z*/]={//indexy vektoru - jednotlive body bounding boxu
{{1,2,4},{1,2,5},{1,3,5},{1,3,4}},
{{0,2,4},{0,2,5},{0,3,5},{0,3,4}},
{{1,3,4},{1,3,5},{0,3,5},{0,3,4}},
{{1,2,4},{1,2,5},{0,2,5},{0,2,4}},
{{1,2,5},{0,2,5},{0,3,5},{1,3,5}},
{{1,2,4},{0,2,4},{0,3,4},{1,3,4}},
};//1..6 ->(hi.x/lo.x,hi.y/lo.y,hi.z/lo.z)


/** vraci num-tou souradnici (1..4) box-teho polygonu (1..6) v bounding boxu */
vector boxv(aa_bbox *orig,int box,int num) {
 vector r;
 r.x=_obox(orig)[indexes[box][num][0]];
 r.y=_obox(orig)[indexes[box][num][1]];
 r.z=_obox(orig)[indexes[box][num][2]];
 return r;
}

/** vraci true pokud doslo ke kolizi.
 v tom pripade je v coll bod kolize a v bounce je bounce-off vektor (normalizovany)
 eabox je move-extended bounding box objektu
 abox je bounding box objektu
 normal je nrormala facu, se kterym se dela test
 nc je pocet souradnic polygonu se kterym se kliduje,
 v facev jsou vertexy jeho facu (odkazy)
 a vert je ukazatel na pole s vertexy
 */
//STARY KOD, nepouziva se
int collision3d(aa_bbox *eabox,aa_bbox *abox,vertex move,vertex normal,vector *coll,vector *bounce,int nc,facecoord *facev,vector *vert) {
 int r,i,j,eflag;
 int box[6]={0,0,0,0,0,0};//ktere strany boxu pripadaji v uvahu ke kolizi (1= preskocit, 0=ok)
 bfloat ray[4];//vzdalenosti jednotlivych primek
 vector pray[4];//body kolizi jednotlivych primek
 ray_plane_intersect rpi;
 if (nc<3) return 0; //s primkami a body nekolidujeme
 //TODO: check for eabox (vertexes)
 if (v_muls(normal,move)<0) return 0; //polygon je opacny vuci smeru pohybu, tedy nemuze vadit
 //sposteme se kterymi stenami by to mohlo eventuelne kolidovat
 if (move.x<=0) box[0]=1; //(hi.x/lo.x,hi.y/lo.y,hi.z/lo.z)
 if (move.x>=0) box[1]=1; //kolize se stenami
 if (move.y<=0) box[2]=1;
 if (move.y>=0) box[3]=1;
 if (move.z<=0) box[4]=1;
 if (move.z>=0) box[5]=1;
 for (i=0;i<6;i++) {
  if (box[i]) continue; //opacna strana boxu nekoliduje
  eflag=0;
  for (j=0;j<4;j++) {
   r=intersect_ray_plane(boxv(abox,i,j),move,planevector(0),normal,&rpi);
   if (!(r & INTERSECT)) break;//paralelni se smerem pohybu, takze nemuze vadit
   ray[j]=rpi.t;
   pray[j]=rpi.p;
   if (rpi.t<1) eflag=1;
  }
  if (!eflag) continue;//bod je moc daleko, ke kolizi nedojde (nebo aspon ne tenhle frame :o)
  if (ray[0]<0 && ray[1]<0 && ray[2]<0 && ray[3]<0) continue;
  debug_printf("move% g %g %g , ray %g %g %g %g\n",all3d(move),ray[0],ray[1],ray[2],ray[3]);
//  fatalf("error!");
  //TODO: kolize s jednotlivymi stranami bboxu
 }
 //nejdriv se zjisti ktere strany bboxu pripadaji v uvahu a pak se dela kolize
 //TODO: hlavni cast kolizi, dodelat!!!
 //tohle bude asi nejslozitejsi algoritmus v enginu
 return 0;
}

//TODO: sjednotit vector a vector2!

/** kolize dvou objektu (dvou aboxu) */
int collision_q(vector *p,aa_bbox *abox,vector2 *move,aa_bbox *obox,vector *coll,vector *bounce) {
 int i,mins=-1;
 bfloat min[3],minl=finf;
 bfloat o_hi,o_lo,a_hi,a_lo;
 for (i=0;i<3;i++) {
  o_lo=_obox(obox)[i  ];
  o_hi=_obox(obox)[i+3];
  a_lo=_obox(abox)[i  ];
  a_hi=_obox(abox)[i+3];
  min[i]=finf;
  if ((o_lo>a_lo && a_lo>o_hi) || (o_lo>a_hi && a_hi>o_hi)) continue;//v souradnici je jiz nekde vevnitr

       if ((move->a[i])<0) min[i]=(o_hi-a_lo)/(move->a[i]);
  else if ((move->a[i])>0) min[i]=(o_lo-a_hi)/(move->a[i]);

  if (min[i]!=finf && min[i]>1) fatalf("chyba:%g at %d!"
"z = %g %g %g\na = [%g %g %g - %g %g %g]\no = [%g %g %g - %g %g %g]\no_hi=%g, o_lo=%g, a_hi=%g, a_lo=%g"
,min[i],i
,all3d(*(vector *)move),all3d(abox->lo),all3d(abox->hi),all3d(obox->lo),all3d(obox->hi),o_hi,o_lo,a_hi,a_lo);
//no collision in this coord
  if (min[i]<0) continue;
  if (min[i]<minl) {
   mins=i;
   minl=min[i];
  }
 }
 if (mins==-1) return 0;
 v_sum1f(coll,*((vector *)move),minl);
 bounce->x=(mins==0?1:0);
 bounce->y=(mins==1?1:0);
 bounce->z=(mins==2?1:0);
 return 1;
}

/** presune objekt, s collision detection */
void move_with_collision(object3d *p,bfloat tick_time) {
//TODO: kolize "kazdy s kazdym" je PRILIS pomala pri newkolika tisicich objektech, to chce dosti zrychlit
//TODO: roztridit do grup: nonphysical(0,2), physical+trigger(1,3). koliduje se jenom vuci P
//TODO: tahle procedurka je celkem chaos, to by chtelo prekopat
 int i;
 vector origp,zbytek;//co zbyva pohnout
 vertex coll; //bod dotyku
 bfloat fcoll;//vzdalenost ke kolizi
 vector bounce;      //bounce-off vektor
 object3d *p2;
 vector lcoll,lbounce;//lokalni collision/bound vektor
 aa_bbox abox; //bbox objektu
 aa_bbox eabox;//move-enlarged bbox objektu
 aa_bbox obox;//bbox objektu se kterym koliduji
 aa_bbox wbox; //bbox sveta
 bfloat bouncev;//jak moc se dotycny objekt odrazi (pruznost)
 zbytek=p->nd;
 if (!zbytek.x && !zbytek.y && !zbytek.z) return;//nehybe se -> nekoliduje
 if (noclip) { //specialni pripad - zapnuty noclip
  p->p.x+=zbytek.x*tick_time;
  p->p.y+=zbytek.y*tick_time;
  p->p.z+=zbytek.z*tick_time;
  if (p->f.copy_d) p->d=zbytek;
  return;
 }
 v_mul(&zbytek,tick_time);//nasobi se delkou framu
 origp=p->p;
 abox=object_abox(p,1);
 wbox=world->m->abox;
// bouncev=-p->f.bounce;
 bouncev=1.0+p->f.bounce;
begin:
 fcoll=finf;//vzdalenost ke klizi je +inf
 eabox=abox;
 abox_enlarge(&eabox,zbytek);
 if (p==vplayer[0]->who) sprintf(info,"coll %5.2f,%5.2f,%5.2f = %5.2f\nbox=<%g %g %g>-<%g %g %g>\nwbox=<%g %g %g>-<%g %g %g>",all3d(zbytek),(double)v_size(zbytek),all3d(abox.lo),all3d(abox.hi),all3d(wbox.lo),all3d(wbox.hi));
//TODO: pozor, coll obsahuje relativni rychlost, ne absolutni pozici
 for (i=0;i<world->obj.numobj;i++) { //kolize typu "kazdy s kazdym"
  p2=world_getobj(world,i);
  if (p2->f.is_physical!=1 || p2==p) continue;//sam se sebou a s nefyzikalnimi objekty nekoliduje
  obox=object_abox(p2,1);
  if (abox_intersect(eabox,obox)) {
   if (collision_q(&p->p,&abox,(vector2 *)&zbytek,&obox,&lcoll,&lbounce)) {
    if (v_size(lcoll)<fcoll) {//nastala blizsi kolize
     coll=lcoll;
     fcoll=v_size(lcoll);
     bounce=lbounce;
    }
   }
  }
 }
 if (fcoll>=finf) { // ke kolizi nedoslo
  p->p.x+=zbytek.x;
  p->p.y+=zbytek.y;
  p->p.z+=zbytek.z;
  if (p->f.copy_d) { //TODO: tenhle vzorec nebere v uvahu odraz - obcas muze dat vysledky, co jsoun lehce mimo
   p->d=v_sub(p->p,origp);
   v_mul(&p->d,1.0/tick_time);//korekce zpet na puvodni hodnoty
  }
  return;
 } else {
  bfloat nbounce;
  //tODO: obcas to zahadne prochazi zdmi
  v_add(&p->p,coll);//presun do bodu kolize
  abox_move(&abox,coll);//posune se bbox o pohyb
  zbytek=v_sub(zbytek,coll);//o kolik se jeste ma posunout
  //TODO: pokud bounce<minbounce, tak bounce=0 (aby se to necamrdilo tam nekde u nuly...)
  //TODO: docasny kod, ihned co to pujde zmenit (poradny bounce)
  nbounce=-v_muls(zbytek,bounce)/v_muls(bounce,bounce);
//  debug_printf("bouncev=%g,nbounce=%g\n",bouncev,nbounce);
//  if (bouncev<1) fatalf("nbounce=%g",bouncev);
//  if (bouncev>2) fatalf("nbounce=%g",bouncev);
  v_addf(&zbytek,bounce,nbounce*bouncev);
//  if (p->copy_d) TODO: zmenit orig, aby ty vektory dobre sedely
//  debug_printf("  =>  %g %g %g -> %g %g %g\n",all3d(bounce), all3d(zbytek));
  goto begin;//na zacatek a test jestli odraz tqaky nekoliduje
 }
 //TODO: collision detection by neskodilo uplne prekopat
 //todo: kolize s worldmodelem, kolize s modely odladit
}


/** aplikuje akceleraci na objekt (hrace) */
void b_applyaccel(object3d *p,bfloat fwd,bfloat right,bfloat up,bfloat last_tick_time) {
 bfloat fade,speed;
 vector head2,left2,up2;
// vector poo;//debug
 fade=(ground_fade*p->pd.touch)+(air_fade*(1-p->pd.touch));
 speed=(move_speed*p->pd.touch)+(move_airspeed*(1-p->pd.touch));
 head2=p->head;
 left2=p->left;
 up2=p->up;
 if (!flymode) {
  //todo: nastavit po smeru gravitace, ne jen ve zmeru osy z;
  v(p->pd.movemask,1,1,0);
  head2.z=0;
  left2.z=0;
  up2.z=1;
  up2.x=0;
  up2.y=0;
  normalize(&head2);
  normalize(&left2);
 } else v(p->pd.movemask,1,1,1);//todo: jumping. ale jinak se nechce pohybovat nahoru nebo dolu
 last_tick_time*=1000;//brute hack, bylo to ve spatnych jednotkach (v milisekundach misto sekund)
 //TODO sjednotit sekundy/milisekundy
 v_addf(&p->d,head2,(1.0-fade)*speed*(last_tick_time)*fwd);
 v_addf(&p->d,left2,(1.0-fade)*speed*(last_tick_time)*right);
 v_addf(&p->d,up2,(1.0-fade)*speed*(last_tick_time)*up);
 if (iszero(p->d)) return; //nehybe se, neni co resit
 p->pd.fade=fade;
 if (size2(p->d)<move_stop*move_stop) zerov(p->d);
/* poo=p->d;
 poo.z=0;
 debug_printf("speed=%g (%g), tick=%g, fade=%g, koef=%g\n",v_size(p->d),v_size(poo),last_tick_time,(1.0-fade),(1.0-fade)*speed*(last_tick_time));*/
}

#ifdef use_ode_lib //code with ODE //[PASS]

/** na objekt aplikuje fyzikalni zakony (tick funkci, pohyb, rotace ...)*/
void b_applyphysics(object3d *p,bfloat tick_time) {
 p->rot.x+=p->rotplus.x*tick_time;
 p->rot.y+=p->rotplus.y*tick_time;
 p->rot.z+=p->rotplus.z*tick_time;
 ai_call_timer(p,p->pd.lifetime,tick_time*1000.0);//zavolani timer(pohybove) funkce objektu
 p->pd.lifetime+=tick_time*1000.0;//doba zivota objektu
}

int num_joints;//debugobvaci promenna, pocet jointu

#define MAX_CONTACTS 4//3 by mozna stacily (dam 3 kdyz to bude pomaly)
/** callback funkce na ODE - kolize */
void b_ode_nearcallback(worldspawn *w,dGeomID o1,dGeomID o2) {
 int i;
 dContact contact[MAX_CONTACTS];//kontakty (max. na nekolika bodech)
 dBodyID b1=dGeomGetBody(o1);
 dBodyID b2=dGeomGetBody(o2);
 int numc;//pocet kontaktu
// if (!b1 && !b2) return;//staticky, nemaj body
 if (b1 && b2 && dAreConnectedExcluding(b1,b2,dJointTypeContact)) return;//pokud jsou spojeny, skoncit
 for(i=0;i<MAX_CONTACTS;i++) { //nastavi parametry kontaktu
  contact[i].surface.mode=dContactBounce;// | dContactSoftCFM;
  contact[i].surface.mu=dInfinity;  //friction ve smeru pohybu (0=hladke, infinitty=100% drsne)
  contact[i].surface.mu2=0;         //friction kolmo na pohyb  (0=hladke, infinitty=100% drsne)
  contact[i].surface.bounce=0.8;    //odrazivost (0=sutr, 1=trampolina)
  contact[i].surface.bounce_vel=0.5;//minimalni rychlost aby se to odrazilo
//  contact[i].surface.soft_cfm=0.01;
 }
 if (numc=dCollide(o1,o2,MAX_CONTACTS,&contact[0].geom,sizeof(dContact))) {
  //TODO: delat zvuky a volat touch funkce tady
  for (i=0; i<numc; i++) {
   dJointID c=dJointCreateContact(w->c.world,w->c.jgroup,contact+i);//vytvorit docasny concact joint
   dJointAttach(c,b1,b2);//spojit 2 objekty
   num_joints++;
  }
 }
}

/** updatuje objekt do kolizniho systemu - vola se po externi zmene objektu (pozice, rotace, atd ....)
nebo pri vytvoreni */
void world_updateobject(worldspawn *w,object3d *o) {
 bfloat lx,ly,lz;
 aa_bbox a=object_abox(o,0);
 int is_static=0;//true pokud ma byt objekt uplne staticky
 if (o->f.is_physical) {//pokud je fyzicky a kolizni objekt 
  if (o->type && eqi(o->type->classname,"func_wall")) is_static=1;
  lx=(a.hi.x-a.lo.x);
  ly=(a.hi.y-a.lo.y);
  lz=(a.hi.z-a.lo.z);
  debug_printf("world_updateobject: begin (%d) (%g,%g,%g)\n",o,lx,ly,lz);
  if (!w->c.world) return;  // pokud svet nebezi, nic se nikam pridavat nebude
  if (!o->geom) { // prvni volani - vytvor geometrii
   o->geom=dCreateBox(w->c.space,lx,ly,lz);
   if (!is_static) o->body=dBodyCreate (w->c.world);
  } else { // dalsi volani -> pouze updatuj gemotetrii
   dGeomBoxSetLengths(o->geom,lx,ly,lz);
  }
  if (!is_static) {
   // nastavi setrvacnost krychle
   dMassSetBox (&o->mass_info,1,lx,ly,lz);
   // nastavi centrum hmotnosti objektu
   //TODO: prej to v ODE blbne - takze centrum je zatim v 0,0,0 - overit/enablovat pripadne
   // dMassTranslate(&o->mass_info,(a.hi.x+a.lo.x)/2.0,(a.hi.y+a.lo.y)/2.0,(a.hi.z+a.lo.z)/2.0);
   dBodySetMass(o->body,&o->mass_info);//nmastavi hmostnost a setrvacnost
   dBodySetLinearVel(o->body,o->d.x,o->d.y,o->d.z);
   dGeomSetBody(o->geom,o->body);
  }
  dGeomSetPosition(o->geom,o->p.x,o->p.y,o->p.z);
  dGeomSetData(o->geom,o);// prida jako userdata pointer na sebe
 }
 world_updateobjectlist(w,o->child);//zavolani na child
// debug_printf("world_updateobject: end (%d)\n",o);
}

/** updatuje seznam objektu do kolizniho systemu */
void world_updateobjectlist(worldspawn *w,objectlist o) {
 int i;
 for(i=0;i<o.numobj;i++) {
  world_updateobject(w,o.obj[i]);
 }
}

/** vezme z ODE pozice objektu v updatuje podle nich dany objetlist */
void b_ode_retrieve_objectlist(objectlist o) {
 int i;
 const dReal *pos;//vracena pozice objektu
// const dReal *R;//rotacni matice telesa 
// bfloat theta;
 debug_printf0("b_ode_retrieve_objectlist\n");
 for(i=0;i<o.numobj;i++) {
  if (o.obj[i]->geom) {
   //pozice objektu
   pos=dGeomGetPosition(o.obj[i]->geom);
   o.obj[i]->p.x=pos[0];
   o.obj[i]->p.y=pos[1];
   o.obj[i]->p.z=pos[2];
   //rotace objektu
/* #define _R(i,j) R[(i)*4+(j)]
   R=dGeomGetRotation(o.obj[i]->geom);
   theta=asin(-_R(0,2));
   o.obj[i]->rot.x=(180/pi)*theta;
   o.obj[i]->rot.z=(180/pi)*asin(_R(1,2)/cos(theta));
   o.obj[i]->rot.y=(180/pi)*asin(_R(0,1)/cos(theta));*/
  //MAJOR TODO: retrieve rotation - fix the code
  }
  if (o.obj[i]->child.numobj>0) b_ode_retrieve_objectlist(o.obj[i]->child);
 }
}

/** vezme z ODE pozice objektu a updatuje pozice ve worldspawnu */
void b_ode_retreive_world(worldspawn *w) {
 debug_printf0("b_ode_retreive_world\n");
 b_ode_retrieve_objectlist(w->obj);
}

/** na kazdy objekt aplikuji fyzikalni zakony  a osetrim kolize, atd ....*/
void b_run_physics(worldspawn *w,bfloat tick_time) {
 int i;
// debug_printf("b_tick: beginphysics cycle");
 if (!tick_time) return;
 dSpaceCollide (w->c.space,w,b_ode_nearcallback);//zjisti kolize
 debug_printf("joints: %d\n",num_joints);
 dWorldStep(w->c.world,tick_time);// posune fyziku
 dJointGroupEmpty(w->c.jgroup);// odstrani docasne jointy
 num_joints=0;
 b_ode_retreive_world(w);
 for(i=0;i<world->obj.numobj;i++) {
  debug_printf0("b_tick: physics cycle %d %d");
  b_applyphysics(world_getobj(world,i),tick_time);//Spusti se jen ODe verze ... (tick funkce a tak ...)
 }
 //MAJOR TODO: naprosto nefunguje. Spravit
 //MAJOR TODO: split d na force + accel
// debug_printf("b_tick: endphysics cycle\n");
}

/** po nahrani sveta spocte/nahraje kolizni data*/
void world_collision_init(worldspawn *w) {
 //TODO: dodelat
 //MAJOR TODO: po prvni nahani sveta uleti hrac nekam uplne do predele
 debug_printf("world_collision_init\n");
 if (!w->c.world) {
  w->c.world=dWorldCreate();
  w->c.space=dHashSpaceCreate(0);
  w->c.jgroup=dJointGroupCreate(0);
 }
 dWorldSetCFM(w->c.world,1e-6);//1e-5 bylo puvodne, 1e-10 je doporucene pro double precision
 dWorldSetGravity(w->c.world,0,0,-200*gravity);//todo: gravity as special proc
 world_updateobjectlist(w,w->obj);// nastavi i vsechny aktualni objekty co tam jsou
 debug_printf("world_collision_init done\n");
}

/** zlikviduje objekt v koliznim systemu, ale necha ho dosud v internich strukturach */
void world_destroyobject(object3d *o) {
 debug_printf("world_destroyobject\n");
 world_destroyobjectlist(o->child);
 if (o->body) dBodyDestroy(o->body);o->body=0;
 if (o->geom) dGeomDestroy(o->geom);o->geom=0;
}

/** zlikviduje objekt v koliznim systemu, ale necha ho dosud v internich strukturach */
void world_destroyobjectlist(objectlist o) {
 int i;
 debug_printf("world_destroyobjectlist\n");
 for(i=0;i<o.numobj;i++) {
  world_destroyobject(o.obj[i]);
 }
}

/** pred znicenim sveta uvolni kolizni data*/
void world_collision_free(worldspawn *w) {
 debug_printf("world_collision_free done\n");
 world_destroyobjectlist(w->obj);// nejdriv zlikviduje objekty
 dJointGroupDestroy(w->c.jgroup);
 dSpaceDestroy(w->c.space);
 dWorldDestroy(w->c.world);
 memset(&(w->c),0,sizeof(w->c));
 debug_printf("world_collision_free done\n");
}

/*
ODE: postup

Create a dynamics world.
Create bodies in the dynamics world.
Set the state (position etc) of all bodies.
Create joints in the dynamics world.
Attach the joints to the bodies.
Set the parameters of all joints.
Create a collision world and collision geometry objects, as necessary.
Create a joint group to hold the contact joints.
Loop:

Apply forces to the bodies as necessary. 
Adjust the joint parameters as necessary. 
Call collision detection. 
Create a contact joint for every collision point, and put it in the contact joint group. 
Take a simulation step. 
Remove all joints in the contact joint group.

Destroy the dynamics and collision worlds.
*/


#else //code WITHOUT ODE //[PASS]

/** na objekt aplikuje fyzikalni zakony (tick funkci, pohyb, rotace ...)*/
void b_applyphysics(object3d *p,bfloat tick_time) {
 p->rot.x+=p->rotplus.x*tick_time;
 p->rot.y+=p->rotplus.y*tick_time;
 p->rot.z+=p->rotplus.z*tick_time;
 ai_call_timer(p,p->pd.lifetime,(int)(tick_time*1000.0));//zavolani timer(pohybove) funkce objektu
 p->pd.lifetime+=tick_time*1000.0;//doba zivota objektu
 if (!p->f.is_physical) return;
 move_with_collision(p,tick_time);
}

/** na kazdy objekt aplikuji fyzikalni zakony  a osetrim kolize, atd ....*/
void b_run_physics(worldspawn *world,bfloat tick_time) {
 int i;
 debug_printf0("b_tick: beginphysics cycle");
 for(i=0;i<world->obj.numobj;i++) {
  debug_printf0("b_tick: physics cycle %d %d");
  b_applyphysics(world_getobj(world,i),tick_time);
 }
 debug_printf0("b_tick: endphysics cycle\n");
}

/** po nahrani sveta spocte/nahraje kolizni data*/
void world_collision_init(worldspawn *w) {
 unused(w);
//DUMMY
}

/** pred znicenim sveta uvolni kolizni data*/
void world_collision_free(worldspawn *w) {
 unused(w);
//DUMMY
}

/** updatuje objekt do kolizniho systemu - vola se po externi zmene objektu (pozice, rotace, atd ....)
nebo pri vytvoreni */
void world_updateobject(worldspawn *w,object3d *o) {
 unused(w);
 unused(o);

//DUMMY
}

#endif//[PASS]