/***
 console/commands system
 + key bindings
*/
#include "b_con.h"

bfloat con_height=0.45;	//vyska konzole [EXT]
bfloat con_alpha=0.5;		//transparentnost konzole [EXT]
bfloat con_font_alpha=0.66;  //transparentnost fontu v konzoli [EXT]
int console_ofs=0;	//od ktere radky oproti posledni zacina vykreslovani konzole [EXT]
int con_plus;		//jestli je na poslednim radku
int con_hist_num;	//kolik je tam prikazu
int con_hist_max=1000;	//kapacita historie prikazu - je-li tam prikazu vic, ty starsi se zacnou mazat (kvuli uspore pameti [EXT]
int silent=1;          //pri 1 nevypisuje tolik hlasek na konzoli (X set to Y a tak ...) [EXT]
console_history *con_hist0,*con_hist;//historie prikazu
console_data *con;	//struktura na praci s konzoli (console buffer) [EXT]
//TODO: prevest na strom
cmd_def *cmd0,*cmd9;//seznam prikazu/promennych

int con_width;//aktualni sirka konzole na obrazovce(ve znacich) [EXT]

char *con_logfile; //logovani konzole do souboru - jmeno souboru [EXT]
char *cmd_autostart; //prikaz spoustejici se pri startu (po nahrani configu) [EXT]
int con_log; //logovani konzole do souboru - enable/disable [EXT]
binding *bind0,*bind9;//spojak s bindy - prirazeni klavesy na urcitou akci [EXT]

//TODO: chybi tu treba delete a i ostatni klavesy .....
int bind_table1[]={GLUT_MOUSE+GLUT_LEFT_BUTTON,GLUT_MOUSE+GLUT_MIDDLE_BUTTON,GLUT_MOUSE+GLUT_RIGHT_BUTTON,
-GLUT_KEY_F1,-GLUT_KEY_F2,-GLUT_KEY_F3,-GLUT_KEY_F4,-GLUT_KEY_F5,-GLUT_KEY_F6,-GLUT_KEY_F7,-GLUT_KEY_F8,-GLUT_KEY_F9,-GLUT_KEY_F10,-GLUT_KEY_F11,-GLUT_KEY_F12,
-GLUT_KEY_LEFT,-GLUT_KEY_UP,-GLUT_KEY_RIGHT,-GLUT_KEY_DOWN,
-GLUT_KEY_PAGE_UP,-GLUT_KEY_PAGE_DOWN,-GLUT_KEY_HOME,-GLUT_KEY_END,
-GLUT_KEY_INSERT,27,' ',13,'\t',8,'/',',','.',';'
};
//[HEADER]extern int bind_table1[];

char bind_table2[elements(bind_table1)][max_keyname_length]={"mouse0","mouse2","mouse1",
 "f1","f2","f3","f4","f5","f6","f7","f8","f9","f10","f11","f12",
 "left","up","right","down",
 "pgup","pgdn","home","end",
 "ins","esc","space","enter","tab","backspace","slash","comma","point","semicolon"
};
//[HEADER]extern char bind_table2[][max_keyname_length];

char key_cmd[k_max][11]={//id prikazu
 "nop",
 "left","right","pitchleft","pitchright","up","down",
 "movefwd","moveback","moveleft","moveright","moveup","movedown",
 "console","fire","nextweap","prevweap","scoreboard",
};
//[HEADER]extern char key_cmd[k_max][11];

char key_names[k_max][max_funcname_length]={//jmena
 "-nop",
 "Turn left","Turn right","-Pitch left","-Pitch right","Look up","Look down",
 "Forward","Back","Strafe left","Strafe right","Move up","Move down",
 "-Toggle Console","Throw bomb","Next Weapon","Previous Weapon","Show scores",
};

//[HEADER]extern char key_names[k_max][max_funcname_length];

/** prida prikaz do historie prikazu v konzoli */
void con_addhist(char *cmd){
 debug_printf0("con_addhist: con_hist_max=%d\n",con_hist_max);
 if (!*cmd) return;
 if (!con_hist) {
  con_hist0=maybe_malloc0(sizeof(console_history));
  if (!con_hist0) return;//Neni pamet. Nevadi
  con_hist_num++;
  con_hist=con_hist0;
 } else {
  while (con_hist->next) con_hist=con_hist->next;//na konec historie
  con_hist->next=maybe_malloc0(sizeof(console_history));
  if (!con_hist->next) return;//Neni pamet. Nevadi
  con_hist_num++;
  con_hist->next->prev=con_hist;
  con_hist=con_hist->next;
 }
 con_hist->cmd=malloc1(strlen(cmd+1));
 strcpy(con_hist->cmd,cmd);
 con_plus=1;
 debug_printf0("con_addhist: con_hist_max=%d\n",con_hist_max);
 while (con_hist0 && con_hist_num>con_hist_max) {
  free(con_hist0->cmd);
  if (!con_hist0->next){
   free0(con_hist0);
   con_hist0=0;
   return;
  }
  con_hist0=con_hist0->next;
  free0(con_hist0->prev);
  con_hist_num--;
 }
}

/** vycisti historii prikazu */
void cmd_clearhist(const char *param) {
 while (con_hist0) {
  free(con_hist0->cmd);
  if (!con_hist0->next){
   free0(con_hist0);
  } else {
   con_hist0=con_hist0->next;
   free0(con_hist0->prev);
  }  
 }
 con_hist_num=0;
 unused(param);
}

/** pohyb v historii nahoru (starsi prikazy) */
char *con_uphist() {
 if (!con_hist) return 0;
 if (con_plus) {con_plus=0;return con_hist->cmd;}
 if (con_hist->prev) con_hist=con_hist->prev;
 return con_hist->cmd;
}

/** pohyb v historii dolu (novejsi prikazy)*/
char *con_downhist(void) {
 if (!con_hist) return 0;
 if (con_hist->next) con_hist=con_hist->next; else { con_plus=1;return "";}
 return con_hist->cmd;
}

/** zaregistuje promennou/funkci pro pouziti na prikazove radce v konzoli. Nejobecnejsi varianta */
void register_special_var(const char *vname,int vtype,bfloat minv,bfloat maxv,void *func1,cmd_fn *sfunc,int vlevel,int saved,const char *helptext) {
 if (!cmd0) {
  cmd0=malloc0(sizeof(cmd_def));
  cmd9=cmd0;
 } else {
  cmd9->next=malloc0(sizeof(cmd_def));
  cmd9=cmd9->next;
 }
 cmd9->func=func1;
 cmd9->special_func=sfunc;
 cmd9->is_saved=saved;
 cmd9->min=minv;
 cmd9->max=maxv;
 cmd9->type=vtype;
 cmd9->name=vname;
 cmd9->help=helptext;
 cmd9->level=vlevel;
}

/** zaregistruje promennou pro pouziti na prikazove radce v konzoli. Vola register_special_var */
void register_var(const char *name,int type,bfloat min,bfloat max,void *func,int level,int saved,const char *helptext) {
 register_special_var(name,type,min,max,func,NULL,level,saved,helptext);
}

/** zaregistruje prikaz pro pouziti na prikazove radce v konzoli. Vola register_special_var */
void register_cmd(const char *name, cmd_fn *func, int level,const char *helptext) {
 register_var(name,string_func,0,0,(void *)func,level,0,helptext);
}

/** zaregistruje bool promennou (0,1) pro pouziti na prikazove radce v konzoli. Vola register_special_var */
void register_bool(const char *name, int *func, int level,int saved,const char *helptext) {
 register_var(name,int_var,0,1,func,level,saved,helptext);
}

/** zaregistruje float promennou (bez omezeni min/max) pro pouziti na prikazove radce v konzoli. Vola register_special_var */
void register_float(const char *name, bfloat *func, int level,int saved,const char *helptext) {
 register_var(name,float_var,-finf,finf,func,level,saved,helptext);
}

/** vraci 1 pokud cmd je prikaz what a nakopiruje parametry do parm */
int iscmd(const char *cmd,const char *what,char *parm) {
 size_t lw=strlen(what);
 size_t lc=strlen(cmd);
 int res=!strnicmp(cmd,what,lw);
 if (res) {
  if (lc>=lw+1) {//mozna nejaky paramter
   res=isseparator(cmd[lw]);
   if (!res) return 0;//prikaz ma stejny koren ale je jiny
   while (isseparator(*(cmd+lw))) {
    lw++;
    if (!*(cmd+lw)) break;
   }
   strcpy(parm,cmd+lw);
  } else parm[0]=0;//nic
 }
 return res;
}

/** vrati prvni slovo z cmd do parm */
void firstword(const char *cmd,char *parm) {
 int max=0;
 while (*cmd) {
  *parm=*cmd;
  cmd++;
  parm++;
  max++;
  if (max>=console_max_cmd-1) break;
  if (isseparator(*cmd)) break;
 }
 *parm=0;
}

/**  vypise radek na konzoli */
void con_print(const char *s) {
 int b,i,l=strlen(s)+1;//vcetne null znaku
 // nejdriv se udela misto v bufferu, aby se to tam veslo -> posouva se line0
 while (con->chars+l>elements(con->buf)) {
  con->chars-=con->len[con->line0];
  con->line0++;
  con->line0%=elements(con->lines);
  con->nlines--;
 }
 if (((con->line9+1)%elements(con->lines))==(con->line0%elements(con->lines))) { //malo radek -> posouva se line0
  con->chars-=con->len[con->line0];
  con->line0++;
  con->line0%=elements(con->lines);
  con->nlines--;
 }
 b=con->lines[con->line9];//line9 ukazuje na volne misto
 con->len[con->line9]=l;  // nastaveni delky radku(line9)
 for(i=0;i<l;i++){      //nakopirovani raadku
  con->buf[b]=s[i]?s[i]:'\n'; 
  b++;
  if (b>=elements(con->buf)) b=0;
 }
 con->chars+=l;          //pocet znaku
 con->line9++;		//dalsi radek
 con->nlines++;
 con->line9%=elements(con->lines);
 con->lines[con->line9]=b;//zacatek dalsiho
 //TODO: maybe scroll to bottom on output
 debug_printf0("CONSOLE: %s\n",s);
 if (con_log && con_logfile && *con_logfile) {
  FILE *f;
  security_check(con_logfile);
  f=fopen2(datadir "/",con_logfile,"ab",0);
  if (!f) return;
  fprintf(f,"%s\n",s);
  fclose(f);
 }
}

/**  formatovany vystup, vypise radek nakonzoli (viz con_print) */
void con_printf (const char *fmt, ...){
 va_list argptr;
 char s[console_max_cmd];
 va_start(argptr,fmt);	
 if (_vsnprintf(s,sizeof(s),fmt,argptr)==-1) s[sizeof(s)-1]=0;
 va_end(argptr);
 con_print(s);
}

/**  formatovany vystup, vypise radek nakonzoli (zalamovany) (viz con_print) */
void con_printfz (const char *fmt, ...){
 va_list argptr;
 int l,le;
 char s[console_max_mline],*c=s;
 va_start(argptr,fmt);	
 if ((l=_vsnprintf(s,sizeof(s),fmt,argptr))==-1) {
  s[sizeof(s)-1]=0;
  l=sizeof(s)-1;
 }
 va_end(argptr);
 while (*c) {
  le=con_width-1;
  if (le>l-1) le=l-1;
  else while (c[le]!=' ') {
   le--;
   if (le==0) {
    le=con_width-1;
    break;
   }
  }
  c[le]=0;
  con_print(c);
  c+=le+1;
  l-=le+1;
 }
}

/**  vypise radek na konzoli - pokud neni nastaven silent flag */
void con_printv(const char *s) {
 if (silent) return;
 con_print(s);
}

/**  formatovany vystup, vypise radek nakonzoli (viz con_printv) - pise pouze pokud neni nastaven silent */
void con_printfv (const char *fmt, ...){
 va_list argptr;
 char s[console_max_cmd];
 if (silent) return;
 va_start(argptr,fmt);	
 if (_vsnprintf(s,sizeof(s),fmt,argptr)==-1) s[sizeof(s)-1]=0;
 va_end(argptr);
 con_printv(s);
}

/** vola se pri spousteni prikazu na konzoli, pokud je spusteny prikaz integer promenna (nastaveni/vypis hodnoty) */
void cmd_ivalue(const char *id,const char *param,int min,int max,int *value) {
 int _; 
 if (!*param) {
  con_printf("%s is %d",id,*value);
  return;  
 }
 _=atoi(param);
 if (min!=(int)-inf) {
  if (_<min) _=min;
 }
 if (max!=(int)inf) {
  if (_>max) _=max;
 }
 con_printfv("%s set to %d",id,_);
 *value=_;
}

/** vola se pri spousteni prikazu na konzoli, pokud je spusteny prikaz string promenna (nastaveni/vypis hodnoty) */
void cmd_svalue(const char *id,const char *param,int min,int max,char **value) {
 if (!*param) {
  con_printf("%s is \"%s\"",id,unnull(*value));
  return;  
 }
 con_printfv("%s set to \"%s\"",id,param);
 if (*value) free(*value);
 *value=strdup(param);
 unused(min);//v budoucnu by mozna mohly omezovat delku retezce nebo mit jiny vyznam
 unused(max);
}

/** vola se pri spousteni prikazu na konzoli, pokud je spusteny prikaz float promenna (nastaveni/vypis hodnoty) */
void cmd_fvalue(const char *id,const char *param,bfloat min,bfloat max,bfloat *value) {
 bfloat _; 
 if (!*param) {
  con_printf("%s is %g",id,(double)*value);
  return;  
 }
 _=atof(param);
 if (min!=-finf) {
  if (_<min) _=min;
 }
 if (max!=finf) {
  if (_>max) _=max;
 }
 con_printfv("%s set to %g",id,(double)_);
 *value=_;
}

/** vola se pri spousteni prikazu na konzoli, pokud je spusteny prikaz vector promenna (nastaveni/vypis hodnoty) */
void cmd_vvalue(const char *id,const char *param,bfloat min,bfloat max,vector2 *value) {
 float f[3]; 
 int i;
 if (!*param) {
  con_printf("%s is <%g,%g,%g>",id,all3d2(*value));
  return;  
 }
 if (sscanf(param,"%f %f %f",f+0,f+1,f+2)<3)
 if (sscanf(param,"%f , %f , %f",f+0,f+1,f+2)<3) return;
 for (i=0;i<3;i++) {
  if (min!=-finf) {
   if (f[i]<min) f[i]=min;
  }
  if (max!=finf) {
   if (f[i]>max) f[i]=max;
  }
  value->a[i]=f[i];
 }
 con_printfv("%s set to <%g,%g,%g>",id,all3d2(*value));
}

tree *alias_tree;//Strom obsahujici aliasy [EXT]

/** najde alias a nahradi prikazovou radku aliasem, pokud uspeje*/
void lookup_alias (char **cmdline) {
 char param[console_max_cmd];
 char *q;
 firstword(*cmdline,param); 
 if_(q=tree_search(alias_tree,param)) *cmdline=q;
}

/** vola se pri spousteni prikazu na konzoli. Funkce zjisti handler (viz register_special_var apod.) a provede prislusnou akci */
void cmd_exec(char *cmdline) {
 char param[console_max_cmd];
 cmd_def *cmd;
 if (!*cmdline) return;
 if (*cmdline=='#' || *cmdline=='/') return;//komentar
 debug_printf("cmd_exec:%s\n",cmdline);
 lookup_alias(&cmdline);
 cmd=cmd0;
 while (cmd) {
  if (iscmd(cmdline,cmd->name,param)) {
   switch(cmd->type) {
    case float_func:fatal("TODO: unsupported: float_func");break;
    case float_var:cmd_fvalue(cmd->name,param,cmd->min,cmd->max,(bfloat *)cmd->func);break;
    case int_func:fatal("TODO: unsupported: int_func");break;
    case int_var:cmd_ivalue(cmd->name,param,(int)cmd->min,(int)cmd->max,(int *)cmd->func);break;
    case string_func:((cmd_fn *)cmd->func)(param);break;
    case string_var:cmd_svalue(cmd->name,param,(int)cmd->min,(int)cmd->max,(char **)cmd->func);break;
    case vector_func:fatal("TODO: unsupported: vector_func");break;
    case vector_var:cmd_vvalue(cmd->name,param,cmd->min,cmd->max,(vector2 *)cmd->func);break;
   }  
   if (cmd->special_func) cmd->special_func(param);
   debug_printf("cmd_executed:'%s' '%s'\n",cmd->name,param);
   return;
  }
  cmd=cmd->next;
 }
 firstword(cmdline,param); 
 con_printf("Unrecognized command: %s",param);
}

/** vypise helptext pro prikaz */
void cmd_help(const char *cmdparam) {
 char param[console_max_cmd];
 cmd_def *cmd;
 if (!*cmdparam) {
  con_printf("Usage: help <command_name>");
  return;
 }
 cmd=cmd0;
 while (cmd) {
  if (iscmd(cmdparam,cmd->name,param)) {
   con_printf("%s: %s",cmd->name,cmd->help);
   return;
  }
  cmd=cmd->next;
 }
 firstword(cmdparam,param); 
 con_printf("No such command: %s",param);
}

/** vnitrni cylkus vypisu aliasu - konzole */
void _aliaslist1(char *name,char *cmd) {
 con_printf("%s = %s",name,cmd);
}

/** vnitrni cylkus vypisu aliasu - soubor */
void _aliaslist2(char *name,char *cmd,FILE *alias_f) {
 fprintf(alias_f,"alias %s %s\n",name,cmd);
}

/** vypise aktualni aliasy do souboru nebo na konzoli (pokud f==NULL) */
void aliaslist(FILE *f) {
 if (!f) {
  con_print("Current aliases:");
  tree_foreach(alias_tree,_aliaslist1);
 } else {
  tree_foreach_p(alias_tree,_aliaslist2,f);
 }
}

/** ulozi aliasy do souboru */
void cmd_savealiases(const char *filename) {
 FILE *f;
 if (empty(filename)) filename=default_alias_file;
 security_check(filename);
 f=fopen2safe(datadir "/",filename);
 aliaslist(f);
 fclose2safe(f);
 con_printfv("Aliases saved to %s",filename);
}

/** spusti konfiguracni soubor z disku */
void cmd_execfile(const char *name) {
 char *cont=0,*curr;
 int i=0;
 int len=fs_loadfile(&cont,name);
 int rest;
 if (!cont) {
  con_printf("Can't execute %s",name);
  return;
 }
 if (!len) return;
 curr=cont;
 while (i<len) {
  if (!cont[i]) cont[i]=' ';
  if (cont[i]==10 || cont[i]==13) {
   cont[i]=0;
   cmd_exec(curr);
   curr=cont+i+1;
  }
  i++;
 }
 rest=cont-curr+len;
 if (rest) {
  curr=malloc1(rest+1);
  b_strncpy(curr,cont+len-rest,rest+1);
  cmd_exec(curr);
  free(curr);
 }
 free(cont);
}

/** ke klici vrati jeho nazev ve statickem retezci */
char *b_keyname (int key) {
 static char keybuf[16];
 int i;
 if (!key) { //nic
  keybuf[0]=0;
  return keybuf;
 }
 if (printable(key)) { //tisknutelny
  keybuf[0]=key;
  keybuf[1]=0;
  return keybuf;
 }
 for (i=0;i<elements(bind_table1);i++) { //je to neco special?
  if (key==bind_table1[i]) return bind_table2[i];
 }
 sprintf(keybuf,"#%d",key);//neznama klavesa
 return keybuf;
}

/** k hraci a ID akce vrati textovou reprezentaci ve statickem retezci */
char *b_actionname (int player,int action) {
 static char abuf[32];
 if (player) {
  sprintf(abuf,"%s%d",key_cmd[action],player);
  return abuf;
 } else return key_cmd[action];
}

/** k Id akce obsahujici hrace vrati textovou reprezentaci ve statickem retezci */
char *b_actionname1 (int action) {
 return b_actionname(action/k_max,action%k_max);
}

/** vypise aktualni keybindings do souboru nebo na konzoli (pokud f==NULL) */
void bindlist(FILE *f) {
 binding *bind;
 char *what;
 if (!f) con_print("Current keybindings:");
 bind=bind0;
 while(bind) {
  if (bind->action>0) {
   what=b_actionname1(bind->action);
/*   if (bind->action>k_max) {
    _snprintf(buf,sizeof(buf),"%s%d",key_cmd[bind->action % k_max],bind->action/k_max);
    what=buf;
   } else what=key_cmd[bind->action];*/
  } else what=bind->command;
   if (f) fprintf(f,"bind %s %s\n",b_keyname(bind->key),what); else con_printf("%s = %s",b_keyname(bind->key),what);
/*  if (printable(bind->key)) {
   if (f) fprintf(f,"bind %c %s\n",bind->key,what); else con_printf("\"%c\" = %s",bind->key,what);
  } else {
   for (i=0;i<elements(bind_table1);i++) {
    if (bind->key==bind_table1[i]) {
     if (f) fprintf(f,"bind %s %s\n",bind_table2[i],what); else con_printf("%s = %s",bind_table2[i],what);
     goto skip;
    }
   }
   if (f) fprintf(f,"bind #%d %s\n",bind->key,what); else con_printf("#%d = %s",bind->key,what);
  }
  skip:*/
  bind=bind->next;
 }
 return;
}

/** ulozi promenne u kterych je nastaven flag ze se maji ukladat do konfiguracniho souboru */
void cmd_saveconfig(const char *filename) {
 cmd_def *cmd;
 FILE *f;
 if (empty(filename)) filename=default_config_file;
 security_check(filename);
 f=fopen2safe(datadir "/",filename);
 cmd=cmd0;
 while (cmd) {
  if (cmd->is_saved) {
   switch(cmd->type) {
    case float_var:fprintf(f,"%s %g\n",cmd->name,(double)*((bfloat *)cmd->func));break;
    case int_var:  fprintf(f,"%s %i\n",cmd->name,*((int *)cmd->func));break;
    case string_var:fprintf(f,"%s %s\n",cmd->name,*((char **)cmd->func));break;
    case vector_var:fprintf(f,"%s %g %g %g\n",cmd->name,all3d(*((vector *)cmd->func)));break;
    default: fatalf("cmd_saveconfig: unknown variable type");
   }  
  }
  cmd=cmd->next;
 }
 fprintf(f,"unbindall\n");
 bindlist(f);
 fclose2safe(f);
 con_printfv("Config saved to %s",filename);
}

/** prevede retezec na scan-kod klavesy/mysiho tlacitka */
int string_to_key(const char *s) {
 int i;
 if (strlen(s)==1) return s[0];//jeden znak. Pismeno
 for (i=0;i<elements(bind_table1);i++){//neco z tabulky
  if (!stricmp(bind_table2[i],s)) {
   return bind_table1[i];
  }
 }
 if (*s=='#') {
  return atoi(s+1);//scankod klavesy
 }
 return atoi(s);//treba to je scankod.
}

/** test jesli je retezec prikaz z priplaclym cislem (pro konkretniho hrace) nebo jestli je bez cisla (pro aktivniho hrace) */
int is_n_cmd(int cmd_num,const char *s) {
 int l=strlen(key_cmd[cmd_num]);
 if (!stricmp(key_cmd[cmd_num],s)) return cmd_num;
 if (!strnicmp(key_cmd[cmd_num],s,l)) {
  int n=atoi(s+l);
  if (n) return cmd_num+n*k_max;
 }
 return -1;
}

/** vytiskne na konzoli jednu polozku pri autocomplete (pokud je vice moznosti) */
void con_autoprint(const char *x,cmd_func t,void *f) {
 switch(t) {
  case(vector_var):con_printf(" %s = <%g,%g,%g>",x,all3d(*(vector *)f));break;
  case(float_var):con_printf(" %s = %g",x,(double)*((bfloat *)f));break;
  case(int_var):con_printf(" %s = %d",x,*((int *)f));break;
  case(string_var):con_printf(" %s = \"%s\"",x,unnull(*(char **)f));break;
  default:con_printf(" %s",x);
 }
}

/** pri zmacnuti tabulatoru se pokusi o autocomplete toho, co je na prikazove radce */
void con_autocomplete(char *cmdline) {
 char param[console_max_cmd];
 cmd_func t=-1;
 void *f=0;
 char *x;
 const char *y;
 int num=0;
 cmd_def *cmd;
 if (!*cmdline) return;
 cmd=cmd0;
 //TODO: tohle predelat: cmd do stromu a autocomplete i na aliasy
 while (cmd) {//vsechny prikazy
  if (!strnicmp(cmdline,cmd->name,strlen(cmdline))) {
   if (!num) {
    b_strncpy(param,cmd->name,console_max_cmd);
    t=cmd->type;
    f=cmd->func;
   } else {
    if (num==1) con_autoprint(param,t,f);
    con_autoprint(cmd->name,cmd->type,cmd->func);
    x=param;
    y=cmd->name;
    while (*x && *y) {
     if (*x!=*y) break;
     x++;y++;
    }
    *x=0;
   }
   num++;
  }
  cmd=cmd->next;
 }
 if (num) b_strncpy(cmdline,param,console_max_cmd);
 if (num==1) {
  x=cmdline+strlen(cmdline);
  *x++=' ';*x=0;
 }
}

/** pri stisknuti klavesy na editacni radku zajisti zprcovani (vcetne backspace, historie, autocomplete ...) */
void editkey(char *s,int c,uint maxlen) {
 char *hist;
 size_t l=strlen(s);
 int con_lines=maxy*con_height/fontsizey;
 if (printablekey(c)) {
  if (l+1>=maxlen) return;
  s[l]=c;
  s[l+1]=0;
 } else if (c=='\t') {//tab, autocomplete
  con_autocomplete(s);
 } else if (c==-GLUT_KEY_PAGE_UP) {
  console_ofs+=con_lines/2+1;
  chopmax(console_ofs,con->nlines-con_lines+2);
  chopmin(console_ofs,0);
 } else if (c==-GLUT_KEY_PAGE_DOWN) {
  console_ofs-=con_lines/2+1;
  chopmin(console_ofs,0);
 } else if (c==-GLUT_KEY_HOME) {
  console_ofs=con->nlines-con_lines+2;
 } else if (c==-GLUT_KEY_END) {
  console_ofs=0;
 } else if (c==8) {//backspace
  if (l>0) s[l-1]=0;
 } else if (c==27) {//esc
  s[0]=0;
 } else if (c==-GLUT_KEY_UP) {
  hist=con_uphist();
  if (hist){
   b_strncpy(con->cmd,hist,console_max_cmd);
  }
 } else if (c==-GLUT_KEY_DOWN) {
  hist=con_downhist();
  if (hist){
   b_strncpy(con->cmd,hist,console_max_cmd);
  }
 } else if (c==13) {//enter
  debug_printf0("editkey: con_hist_max=%d\n",con_hist_max);
  con_addhist(con->cmd);
  cmd_exec(con->cmd);
  con->cmd[0]=0;
 }
}

/** vykresli na obrazovku lines radku konzole, kresli se odzdola nahoru a od posledni radky
    k prvni, prvnich ofs radek je pred kreslenim odzadu preskoceno) */
void con_draw(int ofs,int lines) {
 int i,j,o;
 int l=con->line9-1;
 int stop=con->line0-1;
 if (l<0) l=elements(con->lines)-1;
 if (stop<0) stop=elements(con->lines)-1;
 if (con->line0==con->line9) return;
 glPushMatrix();
 glTranslatex(0,-fontsizey,0);//posun prvniho radku
 glPushMatrix();
 for(i=0;i<ofs;i++){//preskoceni prvnich n radek
  l--;
  if (l<0) l=elements(con->lines)-1;
  if (l==stop) goto end;
 }
 for(i=0;i<lines;i++){
  o=con->lines[l];//startovni pozice;
  for (j=0;j<con->len[l];j++,o++) {  
   if (o>=elements(con->buf)) o=0;
   if (con->buf[o]=='\n') {//newline
    glPopMatrix();
    glTranslatex(0,-fontsizey,0);
    glPushMatrix();
    break;
   }
   glchar(con->buf[o]);
  }
  l--;
  if (l<0) l=elements(con->lines)-1;
  if (l==stop) break;
 }
 end:
 glPopMatrix();
 glPopMatrix();
}

/** vypise retezec na lokalni konzoli */
void cmd_echo(const char *param) {
 con_print(param);
}

/** vycisti konzoli */
void cmd_clear(const char *param) {
 con->line9=con->line0;
 con->chars=0;
 con->nlines=0;
 unused(param);
}

/** odstrani prirazeni prikazu na klavesu */
void cmd_unbind(const char *param) {
 binding *bind,*bindp;
 int kbind=string_to_key(param);
 bind=bind0;
 bindp=0;
 while (bind) {
  if (kbind==bind->key) {//odstranit
   debug_printf0("cmd_unbind: removing key %d bind=%d, bind0=%d, bind9=%d\n",kbind,bind,bind0,bind9);
   if (bind->command) free(bind->command);
   if (bindp) bindp->next=bind->next; else bind0=bind->next;
   if (!bind0) bind9=0;
   if (bind==bind9) bind9=bindp;
   free(bind);
   return;
  }
  bindp=bind;
  bind=bind->next;
 }
}

//TODO: udelat unbind_key, ktery bere keycode a cmd_unbind ho bude volat

/** na prislusnou klavesu nabinduje prislusnou akci */
void bind_key(const char *key,const char *action) {
 int i,j;
 debug_printf0("cmd_bind: unbinded: %s\n",key);
 cmd_unbind(key);
 if (!bind0) {
  bind0=bind9=malloc0(sizeof(binding));
 } else {
  bind9->next=malloc0(sizeof(binding));
  bind9=bind9->next;
 }
 bind9->key=string_to_key(key);
 debug_printf0("cmd_bind: binding to key: %s -> %d\n",key,bind9->key);
 //jde to od 1, protoze prvni je NOP
 for (i=1;i<elements(key_cmd);i++) {// je to nejaky jednoduchy command
  if ((j=is_n_cmd(i,action))>=0) {
   debug_printf0("cmd_bind: binding action: %s -> %d\n",action,j);
   bind9->action=j;
   return;
  }
 }
 // je to slozitejsi prikaz;
 bind9->action=-1;
 bind9->command=strdup(action); 
}

int bench_time;//zacatek mereni casu (milisekund)

/** zacne merit cas */
void bench_start(void) {
 bench_time=gettickcount();
}

/** prestane merit cas a vypise vysledek na konzoli*/
void bench_result(void) {
 int len=gettickcount()-bench_time;
 con_printfv("Done in %d ms",len);
}
