/*** konfigurace ktere se pravdepodobne nebudou, ale obcas muzou zmenit */
#ifndef __B_CONFIG_H__ //include only once
#define __B_CONFIG_H__

#define have_sound // jestli mame zvuk nebo ne
#ifndef RELEASE
#define vdebug //zapne debugging na konzoli
#endif

// 3d model
#define default_maxobj 128 //maximalni ocekavany pocet objektu ve hre (je-li jich vice, provede se realloc).

// CONSOLE system
#define console_lines 1024   //pocet radek v konzoli
#define console_avg_width 80 //ocekavana velikost radku (tohle * pocet radku=velikost bufferu)
#define console_max_cmd 512  //maximalni delka prikazu v konzoli
#define console_max_mline 4096  //maximalni delka radky najednou vypsane na konzoli (pozor, alokuje se na stacku, byt jen max. jednou)

// veci co souvisi s Debuggingem
#ifdef vdebug
#define debug_printf printf //debugovaci vystup
#define debug_printf0 //debugovaci vystup nizsi urovne - vetsinou byva vypnut
#else
#define debug_printf //pri vypnutem debuggingu se nic nevypisuje
#define debug_printf0 //debugovaci vystup nizsi urovne - vypnut
#endif

#define error_printf con_printf //muze byt i fatalf, to pak sleti hned a nebude to jenom varovat

#ifdef vdebug // vraci se pokud je w==null, pri debugu vypise jeste hlasku na stdout
#define exist_or_return(w,s) if (!(w)) { printf("%s: NULL pointer warning\n",(s));return;}
#define exist_or_returni(w,s,n) if (!(w)) { printf("%s: NULL pointer warning\n",(s));return (n);}
#else
#define exist_or_return(w,s) if (!(w)) return
#define exist_or_returni(w,s,n) if (!(w)) return (n)
#endif

#undef automatic_call_list //pokud zapnuto, tak kazdy model se prevede na call-list. To je ovsem problem pri vetsim poctu polygonu...

#define inf 0x7fff0000 	// specialni konstanta znacici "nejvetsi int" (nekonecno). 0x7fffffff nemuze byt, protoze se musi vejit do floatu a byt < MAXINT
#define finf 9.9e35f    // specialni konstanta znacici "velmi velky float" (nekonecno)
                        // vsechny rozmery a souradnice a rychlosti.... musi byt mensi nez finf
                        // (coz neni problem, v pripade souradnic mame prostor krychle o hrane asi 6*10^18 svetelnych let, coz staci :o)

#define precision_double //pokud je definovano, tak se pouzije vsude double, jinak float
//na linuxu spolehlive funguje normalni, na windowsech double ... problem se objevuje
//hlavne u map loadingu. Na linuxu nestmi byt zapnute -ffast-math (jinak jde program
//rychle do kytek)
#ifdef precision_double
 typedef double bfloat; //vsude se pouzije double
 #define glVertex3x glVertex3d //alias na funkci s pouzitim double
 #define glTexCoord2x glTexCoord2d //alias na funkci s pouzitim double
 #define glTranslatex glTranslated //alias na funkci s pouzitim double
 #define glRotatex glRotated //alias na funkci s pouzitim double
 #define glScalex glScaled //alias na funkci s pouzitim double
 #define glColor3x glColor3d //alias na funkci s pouzitim double
 #define glColor4x glColor4d //alias na funkci s pouzitim double
#else
 typedef float bfloat; //vsude se pouzije float
 #define glVertex3x glVertex3f //alias na funkci s pouzitim float
 #define glTexCoord2x glTexCoord2f //alias na funkci s pouzitim float
 #define glTranslatex glTranslatef //alias na funkci s pouzitim float
 #define glRotatex glRotatef //alias na funkci s pouzitim double
 #define glScalex glScalef //alias na funkci s pouzitim float
 #define glColor3x glColor3f //alias na funkci s pouzitim float
 #define glColor4x glColor4f //alias na funkci s pouzitim float
#endif

#define _inline_ __inline //definice inline funkce (kterou lze optimalizovat jako inline)

//vektor/vertex je tu  proto, ze:
//- vychazi z bfloatu
//- pouziva se vsude a ne vsude muzu naincludobvat b_math.h nebo b_types.h, kam by spravne mel patrit
//TODO: vyhazet z b_types.h GL veci a soupnout tam vektor zpet a includovat b_types.h v b_math.h.h
#define vertex vector	//jiny nazev pro vector
#define vertex2 vector2 //jiny nazev pro vector2
typedef struct { //vektor
  bfloat x,y,z; //souradnice ve vektoru (x,y,z)
} vector;

typedef struct { //alternativni definice vektoru
 bfloat a[3];  //pole slozek vektoru
} vector2;//TODO: proc ne jen pole 3 floatu?

//TODO: tohle by se mohlo mozna hodit do b_util.h
#ifndef max
#define max(x,y) (((x)>(y))?(x):(y)) //maximum ze dvou cisel
#endif
#ifndef min
#define min(x,y) (((x)>(y))?(y):(x)) //minimum ze dvou cisel
#endif

#endif // of __B_CONFIG_H__