#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "b_config.h"

#define all3(v) (v).x,(v).y,(v).z //z vektoru vyrobi seznam jeho slozek jako 3 parametry
#define all3d(v) (double)(v).x,(double)(v).y,(double)(v).z //z vektoru vyrobi seznam jeho slozek jako 3 parametry (double)
#define all3d2(v) (double)((v).a[0]),(double)((v).a[1]),(double)((v).a[2]) //z vektoru vyrobi seznam jeho slozek jako 3 parametry (double)
#define v_size(x) (sqrt(size2(x)))//velikost vektoru
#define iszero(v) ((v).x==0.0 && (v).y==0.0 && (v).z==0.0) //test na nulovost vektoru
#define v(w,x1,y1,z1) (w).x=(x1);(w).y=(y1);(w).z=(z1); //vytvoreni vektoru ze slozek
#define zerov(v) (v).x=(v).y=(v).z=0	//vynulovani vektoru
#define zero2(x,y) (x)=(y)=0		//vynulovani 2 cisel

typedef enum{ //pruniky rovin a primek
 NO_INTERSECT   =0,
 INTERSECT      =1,
 INTERSECT_BACK =2 + INTERSECT,
 IDENTICAL      =4,
 PARALLEL       =8,
} geom_intersect;

typedef struct {// struktura vysledku pruniku rovin
 vector p;   //bod na pruniku (primce)
 vector d;   //direction (smernice primky)
 vector in1; //vektor dovnitr prvni roviny
 vector in2; //vektor dovnitr druhe roviny
} plane_plane_intersect;

typedef struct {// struktura vysledku pruniku primky a roviny
 vector p; // bod pruniku
 bfloat t;    //pozice na primce
} ray_plane_intersect;

typedef struct {// struktura vysledku pruniku primek
 vector p; // bod pruniku
 bfloat a;    //pozice na prvni primce
 bfloat b;    //pozice na druhe primce
} ray_ray_intersect;

#define intersect_plane_ray(v2,n2,v1,d1,i) intersect_ray_plane(v1,d1,v2,n2,i) //alias s prohozenymi parametry

#define irandom(x) ((int)brandom(x))//signed int random number

#ifdef _WIN32
 //Inline funkce jsou tady - ty musi byt v hlavicce a ne v .c souboru
 // (jinak to v msvc nefunguje, neb msvc inline funkce do objektu nedava ...)
 #pragma warning(disable : 4514) //unreferenced inline function has been removed
 #include "b_math_in.c"
#else
 //a na rozumnejsich systemech naincludujeme jen hlavicky
 #include "b_math_in.h"
#endif
