#include "b_mem.h"
#include <memory.h>
#include "b_util.h"
/*** Sprava pameti */

#define outofmem "Out of memory: cannot allocate %i bytes " //hlaska co bude hozena pri nedostatku pameti

/** prealokuje pamet. Selhani nepovoleno (viz malloc1) */
void *realloc1(void *x,size_t t) {
 void *i=realloc(x,t);
 if (!i) fatalf(outofmem " (realloc)",t);
 return i;
}

/** naalokuje pamet. Selhani neni povoleno (pri nedostatku pameti program konci s chybovou hlaskou) */
void *malloc1(size_t t){
 void *c;
 c=malloc(t);
 if (!c) fatalf(outofmem " (malloc)",t);
 return c;
}

/** naalokuje pamet. Selhani neni povoleno (vede k padu programu, viz malloc1), pamet vyplnena nulama */
void *malloc0(size_t t){
 void *c;
 c=malloc1(t);
 memset(c,0,t);
 return c;
}

/** naalokuje pamet. Vrati 0 pri selhani */
void *maybe_malloc1(size_t t) {
 return malloc(t);
}

/** naalokuje pamet a vyplni nulama.  Vrati 0 pri selhani */
void *maybe_malloc0(size_t t){
 void *c;
 c=malloc(t);
 if (c) memset(c,0,t);
 return c;
}

