/*** 
 veskere GUI (ruzna menu)
 a HUD (head up display) funkce
*/

//TODO: hud a menu casem oddelit
#include "b_menu.h"

menusystem *msys0,*msys9;//system menu - ke kazdemu menu je prirazeno jmeno a menu jsou ve spojaku

active_menu activemenu;//aktivni menu (na obrazovce) [EXT]
int menupos;		//pozice kurzoru v menu
int menulen;		//pocet polozek menu
int menuwidth;		//sirka menu (ve znacich)

tabs *menutabs;//zalozky v menu - pripadne naalokovane (zero-terminated)
bfloat bindmenu_page_size=5; //velikost stranky v bindmenu
int activetab;//aktivni zalozka v menu

int press_a_key_mode;//zdali to chce novou klavesu
properties *bind_applykeys;//ulozene klice, po zmacknuti Ok se aplikuji

char *menu_warning;//varovani ktere se zobrazuje v menu (napr. ze klavesa byla prirazena jinde) NULL = zadne varovani

uint bind_caption_size;//delka maximalne dlouheho popisku (ve znacich)

intermission *intermis;//aktualni intermission [EXT]


//TODO; advanced menu by se mely nahravat odnekud ze souboru
char advanced_menu_caption[][26]={ //popisky netrivialnich akci ktere se daji nastavit v binding menu
"Screenshot","Pause","Keybindings menu","Main menu",
"Exit game","Add player","Remove last player","Switch to next player"
};

char advanced_menu_command[][18]={ //prikazy netrivialnich akci ktere se daji nastavit v binding menu
"screenshot","pause","menu_bind","menu main",
"quit","player_add","player_kill last","player_next"
};

#define advanced_menu_size (elements(advanced_menu_command)) //pocet advanced prikazu nastavitelnych v menu

/** odalokuje zalozky (tabs) z pameti */
void menu_tabs_destroy(tabs *t) {
 int i=0;
 for (i=0;i<t->num;i++) {
  if (t->t[i].caption) free(t->t[i].caption);
  if (t->t[i].data) {
   if (t->t[i].destructor) t->t[i].destructor(t->t[i].data);
   else free(t->t[i].data);
  }
  i++;
 }
 free(t->t);
 free(t);
}

/** vytvori system zalozek.
 Definice tvaru "Popis1|Popis2|..."
 mult - pokud je zalozka se znakem #, tak se zopakuje mult-krat, znak # nahrazen cislem 1..mult, znak # se nesmi vyskytovat vice nez jednou. 0=tahle feature je vypnuta
 destr - destruktor na data
 */
tabs *menu_tabs_create(const char *def,int mult,vp_fn *destr) {
 tabs *t;
 tab *x;
 int i,j;
 char *p;
 if (mult<0) mult=0;
 t=malloc0(sizeof(tabs));
 i=str_count(def,'#');//nasobne taby
 t->num=str_count(def,'|')+1+i*(mult-1);
 t->t=malloc0(sizeof(tab)*t->num);
 for (i=0;i<t->num;i++) { //pro kazdy tab
  x=&(t->t[i]);
  x->caption=str_chop_until((char **)&def,"|");
  x->destructor=destr;
  if (mult && (p=strchr(x->caption,'#'))) { //p - adresa znaku # v retezci (nebo null)
   for (j=2;j<=mult;j++) {
    i++;
    t->t[i].caption=str_nreplace(x->caption,j);
    t->t[i].destructor=destr;  
   }
   *p='1';
  }
 }
 return t;
}

/** prida do aktualni radky v bindmenu klavesu */
void menu_item_addkey(menu_bind *b,int key) {
 int j;
 for(j=0;j<max_keys_on_action;j++) {//najdi volny key
  if (!b->keys[j]) {
   b->keys[j]=key;
   return;
  }
 }
}

/** vyskoci z menu a pripadne odalokuje struktury, ktere byly naalokovany */
void menu_destroy() {
 activemenu.type=mtype_none;
 if (menutabs) {
  menu_tabs_destroy(menutabs);
  menutabs=0;
 }
 if (menu_warning) {
  free(menu_warning);
  menu_warning=0;
 }
 if (bind_applykeys) {
  freeproperties(bind_applykeys);
  bind_applykeys=0;
 }
}

/** osetri zmacknutou klavesu v menu */
void menukey_simple(int c) {
 char *cmd;
 switch(c) {
  case -GLUT_KEY_PAGE_UP:case -GLUT_KEY_HOME: menupos=0;break;
  case -GLUT_KEY_PAGE_DOWN:case -GLUT_KEY_END: menupos=menulen-1;break;
  case -GLUT_KEY_UP:menupos--;if (menupos<0) menupos=0;break;
  case -GLUT_KEY_DOWN:menupos++;if (menupos>=menulen) menupos=menulen-1;break;
  case 27:menu_destroy();break;
  case ' ':case 13:
   cmd=(activemenu.menucontent.menu+menupos)->command;
   menu_destroy();
   cmd_exec(cmd);
   break;  
 }
}

/** vykresli pozadi menu - obdelnik na zadanych souradnicich a zadane velikosti a nastavi orezavani na jeho hranice, pouzije vybranou texturu z menu*/
void menu_rectangle(bfloat mposx, bfloat mposy,bfloat menux,bfloat menuy,int tex){
 gl_2dclip(mposx,mposy,menux,menuy);//clipping
 glColor4ub(255,255,255,menu_alpha);
 gl_settexture(tex_menu[tex]);
 gl_rectangle(mposx,mposy,mposx+menux,mposy+menuy);
}

/** zobrazi jednoduche menu na obrazovce */
void menu_displaysimple(menuitem *m) {
 int i;
 bfloat menux,menuy,mposx,mposy;
 bfloat menuscale=1.0;
 glPushMatrix();
 menux=(fontsizex*(menuwidth+menuborder_x));
 menuy=(fontsizey*(menulen+menuborder_y));
 while (menux*3<maxx && menuy*3<maxy) {
  menuscale*=2;
  menux*=2;
  menuy*=2;
 }
 mposx=(maxx-menux)/2;
 mposy=(maxy-menuy)/2;
 menu_rectangle(mposx,mposy,menux,menuy,0);
 glTranslatex(mposx+fontsizex*menuscale*(menuborder_x*0.5),mposy+fontsizey*menuscale*(menuborder_y*0.5),0);
 glScalex(menuscale,menuscale,menuscale);
 for (i=0;i<menulen;i++) {
  if (i==menupos) {
   glColor4ub(menu_active_r,menu_active_g,menu_active_b,menu_font_alpha);
  }
  else  glColor4ub(menu_inactive_r,menu_inactive_g,menu_inactive_b,menu_font_alpha);
  gltext(m->label);
  glTranslatef(0,fontsizey,0);
  m++;
 }
 glPopMatrix();
 gl_2dclip(0,0,0,0);
}

/** vyvola bindmenu */
void cmd_bindmenu(const char *param) {
 binding *bind;
 menu_bind *q;
 int maxplayer=0,pl,ac,i,j,k;
 menu_destroy();
 activemenu.type=mtype_bind;
 activetab=0;
 bind_caption_size=0;
 menulen=2;//Ok + cancel, minimalne ....
 menupos=menuwidth=0;
 for(bind=bind0;bind;bind=bind->next) { // zjisti nejvyssiho nabindovaneho hrace
  if (bind->action>=0) {
   pl=bind->action/k_max;
   if (pl>maxplayer) maxplayer=pl;
  }
 }
 menutabs=menu_tabs_create("Advanced|Active Player|Player #",maxplayer+1,0);
 menutabs->t[0].typ=1;
 q=menutabs->t[0].data=malloc0(sizeof(menu_bind)*advanced_menu_size);
 for(j=0;j<advanced_menu_size;j++) {
  q[j].action=-1;
  q[j].command=advanced_menu_command[j];
  q[j].name=advanced_menu_caption[j];
  bind_caption_size=max(bind_caption_size,strlen(q[j].name));
 }  
 menutabs->t[0].count=advanced_menu_size;
 for (i=1;i<maxplayer+3;i++) { /// nacpe do dat popisky pro kazdy tab 
  menutabs->t[i].typ=1;
  q=menutabs->t[i].data=malloc0(sizeof(menu_bind)*k_max);
  for(j=1,k=0;j<k_max;j++) {
   if (key_names[j][0]!='-') {//co zacina - se ma preskocit
    q[k].action=j;
    q[k].name=key_names[j];
    bind_caption_size=max(bind_caption_size,strlen(q[k].name));
    k++;
   }
  }  
  menutabs->t[i].count=k;//pocet radek v tabu
 }
 for(bind=bind0;bind;bind=bind->next) { // projde bindy, vyplni klavesy
  if (bind->action>=0) {
   pl=bind->action/k_max;
   ac=bind->action%k_max;
   q=menutabs->t[pl+1].data;
   for(k=0;k<k_max;k++) { // najdu spravnou akci
    if (ac==q[k].action) break;
   }
   if (k==k_max) continue;//pro tohle neni v menu misto
   menu_item_addkey(q+k,bind->key);
/*   for(j=0;j<max_keys_on_action;j++) {//najdi volny key
    if (!q[k].keys[j]) {
     q[k].keys[j]=bind->key;
     break;
    }
   }*/
   #ifdef vdebug
   if (j==max_keys_on_action) debug_printf("Too many keys on action key=%d pl/act=%d/%d\n",bind->key,pl,ac);
   #endif
  } else {// bind <0 -> look at command
   q=menutabs->t[0].data;
   for(j=0;j<advanced_menu_size;j++) {
    if (eqi(q[j].command,bind->command)) menu_item_addkey(q+j,bind->key);  // je to on - priradit klavesu
   }  
  }
 }
 // a je to
 unused(param);
}

/** prida keybind do seznamu k aplikovani na aktualni tab v menu a pozici v menu. Zaroven odstrani v menu stary zaznam (je-li)*/
void menu_bind_key_add(int c,int player,int action,const char *command) {
 int i,k,t,bsize;
 menu_bind *q;
 const char *what;
 what=(action==-1)?command:b_actionname(player,action);
 property_add(&bind_applykeys,b_keyname(c),what);
 for (t=0;t<menutabs->num;t++) {//for each tab
  if (menutabs->t[t].typ==1) { // is simple bind
   q=menutabs->t[t].data;
   for (i=0;i<menutabs->t[t].count;i++) {//for each line
    for (k=0;k<max_keys_on_action;k++) {//for each key
     if (q->keys[k]==c) {
      if (menu_warning) free(menu_warning);
      bsize=maxx/fontsizex;
      menu_warning=malloc1(bsize);
      what=(q->action==-1)?q->command:b_actionname(t-1,q->action);
      _snprintf(menu_warning,bsize,"Warning: Key %s was bound to %s previously",b_keyname(c),what);
      menu_warning[bsize-1]=0;
      while(k<max_keys_on_action-1) {//posun ostatni klice zpet
       q->keys[k]=q->keys[k+1];
       k++;
      }
      q->keys[k]=0;
      return;//vic nez jednou tam ta klavesa principielne byt nemuze
     }
    }
    q++;
   }
  }
 }
}

/** aplikuje zmeny, ktere byly nastavene v bindmenu */
void menu_bind_save_setting() {
 properties *p=bind_applykeys;
 con_print("New keys applied");
 while (p) { 
  debug_printf0("applied key: %s to %s",p->k,p->v);
  bind_key(p->k,p->v);
  p=p->next;
 }
}

/** osetri zmacknutou klavesu v bindmenu */
void menukey_bind(int c) {
 int i;
 menulen=menutabs->t[activetab].count+2;//delka menu v aktivni zalozce
 if (press_a_key_mode) { // cekali jsme na klavesu kvuli keybindingu
  if (menutabs->t[activetab].typ==1) { // simplebind
   menu_bind *q;
   q=menutabs->t[activetab].data;
   for (i=0;i<max_keys_on_action;i++) {//add key
    if (!q[menupos].keys[i] || q[menupos].keys[i]==c) { //prazdny, nebo tam uz je
     if (!q[menupos].keys[i]) menu_bind_key_add(c,activetab-1,q[menupos].action,q[menupos].command);
     q[menupos].keys[i]=c;
     break;
    }
   }
   if (i==max_keys_on_action) { //push old out
    for (i=0;i<max_keys_on_action-1;i++) {//add key
     q[menupos].keys[i]=q[menupos].keys[i+1];
    }
    menu_bind_key_add(c,activetab-1,q[menupos].action,q[menupos].command);
    q[menupos].keys[max_keys_on_action-1]=c;//pushne se pryc, ale v podstate zustane nabindovan
   }
  }
  press_a_key_mode=0;
  return;
 }
 switch(c) {
  case -GLUT_KEY_PAGE_UP:
   if (menupos<=menulen-3) menupos-=(int)floor(bindmenu_page_size);
   else menupos--;//=menulen-3
   break;
  case -GLUT_KEY_PAGE_DOWN:
   if (menupos<menulen-3) menupos=min(menupos+(int)floor(bindmenu_page_size),menulen-3);
   else menupos++;//=menulen-1;
   break;
  case -GLUT_KEY_HOME: menupos=0;break;
  case -GLUT_KEY_END: if (menupos<menulen-3) menupos=menulen-3; else menupos=menulen-1;break;
  case -GLUT_KEY_UP:menupos--;break;
  case -GLUT_KEY_DOWN:menupos++;break;
  case -GLUT_KEY_LEFT:activetab--;break;
  case -GLUT_KEY_RIGHT:activetab++;break;
  case ' ':case 13:
   if (menupos<menutabs->t[activetab].count) press_a_key_mode=1;
   else {
    if (menupos==menulen-2) menu_bind_save_setting();
    menu_destroy();
   }
   return;  
  case 27:
   menu_destroy();
   return;  
 }
 menulen=menutabs->t[activetab].count+2;//delka menu v aktivni zalozce
 chopmax(menupos,menulen-1);//korekce na min/max...
 chopmin(menupos,0);
 chopmax(activetab,menutabs->num-1);
 chopmin(activetab,0);
}

/** vykresli zalozky na dane pozici menu v prostoru danem jeho sirkou. Na vysku zalozky zaberou 2*fontsizex pixelu, na sirku maximalne <u>mwidth</u> */
void menu_displaytabs(int mposx,int mposy,int mwidth) {
 int i;
 int ttsize=0;//total tab size
 int ttstart=0;//start of actual tab
 int ttstop=0;//end of actual tab
 int ttofs;//offset of moving the tabsystem
 int tsize,tpos;
 tpos=1;
 for (i=0;i<menutabs->num;i++) {
  tsize=(strlen(menutabs->t[i].caption)+3)*fontsizex;
  ttsize+=tsize;
  if (i<activetab) ttstart+=tsize;
  if (i<=activetab) ttstop+=tsize;
  menutabs->t[i].pixelsize=tsize;
 }
 ttofs=(ttstop+ttstart-mwidth)/2;
 if (ttofs>ttsize-mwidth) ttofs=ttsize-mwidth;
 if (ttofs>ttstart) ttofs=ttstart;
 if (ttofs<0) ttofs=0;
 if (ttofs!=0) glTranslatex(-ttofs,0,0);
 for (i=0;i<menutabs->num;i++) {
  if (i==activetab) gl_settexture(tex_menu[1]);
  else gl_settexture(tex_menu[2]);
  tsize=menutabs->t[i].pixelsize;
  gl_rectangle(mposx+tpos,mposy,mposx+tpos+tsize,mposy+fontsizey*2);
  gltext_at(menutabs->t[i].caption,mposx+tpos+1.5*fontsizex,mposy+fontsizey*0.75);
  tpos+=tsize;
 }
 if (ttofs!=0) glTranslatex(ttofs,0,0);//move back
}

/** zobrazi horizontalni scrollbar
 (x,y) souradnice praveho horniho rohu
 (xw,yw) velikost
 i   - aktualni hodnota posunuti scrollbaru
 max - maximalni posuv scrollbaru (i je mezi 0 a max)
 pct - sirka scrollbaru relativni (0..1)
*/
void menu_scrollbar_h(bfloat x,bfloat y,bfloat xw,bfloat yw,bfloat i,bfloat max,bfloat pct) {
 if (i<0) i=0;
 if (i>max) i=max;
 gl_settexture(0);
 glColor4ub(  0, 64, 64,menu_alpha);
 gl_rectangle(x,y,x+xw,y+yw);
 glColor4ub(  0,128,255,menu_alpha);
 gl_rectangle(x,y+(i*(1-pct)/max)*yw,x+xw,y+(i*(1-pct)/max+pct)*yw);
}

/** zobrazi menu na editaci keybindings */
void menu_displaybindeditor() {
 int i,j,msize;
 bfloat iofs,max_iofs,pct_iofs;
//todo: render to texture a zobrazit naraz
 int menux,menuy,mposx,mposy,ompx,omx;
 menu_bind *q;
 tab *atab;
 char table_header[128];//hlavicka tabulky, uzpusobi se velikosti popisku
 glPushMatrix();
 menux=maxx*0.90;
 menuy=maxy*0.90;
 mposx=(maxx-menux)/2;
 mposy=(maxy-menuy)/2;
 menu_rectangle(mposx,mposy,menux,menuy,0);
 if (menu_warning) {
  glColor4ub(255,  0,  0,menu_font_alpha);
  gltext_center(menu_warning,mposy+fontsizey*0.5);
 } else {
  glColor4ub(255,255,255,menu_font_alpha);
  gltext_center("Keybind settings",mposy+fontsizey*0.5);
 }
 mposy+=fontsizey*2;
 menuy-=fontsizey*2;
 glColor4ub(255,255,255,menu_font_alpha);
 menu_displaytabs(mposx,mposy,menux);
 mposy+=fontsizey*2;
 menuy-=fontsizey*2;
 msize=2/*OK,cancel*/+1/*hlavicka tabulky*/;
 bindmenu_page_size=((float)menuy)/((float)fontsizey)-msize;
 if (bindmenu_page_size<1) bindmenu_page_size=1;
 atab=&(menutabs->t[activetab]);
 if (atab->count && atab->data) {
  if (atab->typ==1) {
   q=atab->data;
   gl_settexture(0);
   glColor4ub(  0,  0,255,menu_alpha);
   gl_rectangle(mposx,mposy,mposx+menux,mposy+fontsizey);
   glColor4ub(255,  0,  0,menu_font_alpha);
   _snprintf(table_header,sizeof(table_header),"Function%*sKey(s)",max(0,bind_caption_size-4)," ");
   gltext_at(table_header,mposx+fontsizex,mposy);
   gl_2dclip(mposx,mposy+fontsizey,menux,bindmenu_page_size*fontsizey);//orezani na rozmery okna
   iofs=menupos-bindmenu_page_size/2+0.5;
   max_iofs=atab->count-bindmenu_page_size;
   pct_iofs=bindmenu_page_size/atab->count;
   if (iofs>max_iofs) iofs=max_iofs;
   if (iofs<0) iofs=0;
   if (pct_iofs<1) { //then display scrollbar
    menu_scrollbar_h(mposx+menux-fontsizex,mposy+fontsizey,fontsizex,fontsizey*bindmenu_page_size,iofs,max_iofs,pct_iofs);
   }
   for (i=0;i<min(atab->count,(int)floor(bindmenu_page_size)+1 +100);i++) {
    if (i<iofs-1) continue; //mimo obrazovku
    if (i==menupos) glColor4ub(255,255,  0,menu_font_alpha);
    else glColor4ub(222,222,222,menu_font_alpha);
    gltext_at(q[i].name,mposx+fontsizex,mposy+(i-iofs+1)*fontsizey);
    for (j=0;j<max_keys_on_action;j++) {
     gltext_at(b_keyname(q[i].keys[j]),mposx+(bind_caption_size+3+j*max_keyname_length)*fontsizex,mposy+(i-iofs+1)*fontsizey);//todo: better
    }
   }
  }
 }
 //TODO: ty buttonky do spec. procedury ... nekdy pozdejc, mozna
 //OK/cancel
 omx=menux;
 ompx=mposx;
 mposy=mposy+menuy-1.9*fontsizey;
 menux=8*fontsizex;
 menuy=1.8*fontsizey;
 mposx=ompx+omx/4-menux/2;menu_rectangle(mposx,mposy,menux,menuy,3);
 if (menupos==menulen-2) glColor4ub(255,255,  0,menu_font_alpha);else glColor4ub(222,222,222,menu_font_alpha);
 gltext_at("  OK",mposx+fontsizex,mposy+fontsizey*0.5);
 mposx=ompx+3*omx/4-menux/2;menu_rectangle(mposx,mposy,menux,menuy,3);
 if (menupos==menulen-1) glColor4ub(255,255,  0,menu_font_alpha);else glColor4ub(222,222,222,menu_font_alpha);
 gltext_at("Cancel",mposx+fontsizex,mposy+fontsizey*0.5);
 if (press_a_key_mode) {
  menux=fontsizex*20;
  menuy=fontsizey*4;
  mposx=(maxx-menux)/2;
  mposy=(maxy-menuy)/2;
  menu_rectangle(mposx,mposy,menux,menuy,0);
  gltext_center("Press desired key",mposy+fontsizey);
  gltext_center("or mouse button",mposy+2*fontsizey);
 }
 gl_2dclip(0,0,0,0);//turn clipping off
 glPopMatrix();
}

/** nastavi jeden menuitem dle definice a z posune ukazatel na retezec s definicci na dalsi cast (dalsi polozku menu) */
void menu_setitem(menuitem *m,char **def) {
 m->label=str_chop_until(def,";|");
 if (**def==';') (*def)++;// strednik preskocime
 m->command=str_chop_until(def,"|");
 if (**def=='|') (*def)++;// separator preskocime
 debug_printf0("menu: added %s,%s to menu\n",m->label,m->command);
}

/** z definice typu caption;prikaz [ | caption;prikaz ....] vytvori menu */
menuitem *menu_from_def(const char *def) {
 int n,i;
 menuitem *menu;
 if (!def) return 0;
 n=str_count(def,'|')+1;
 menu=malloc1(sizeof(menuitem)*(n+1));
 for(i=0;i<n;i++) {
  menu_setitem(menu+i,(char **)&def);
 }
 menu[n].label=0;
 menu[n].command=0;
 return menu;
}

/** prida menu s nazvem v name a definici v param */
void menu_addmenu(const char *name,const char *def) {
 if (!msys0) { // uplne prvni menu
  msys0=malloc0(sizeof(menusystem));
  msys9=msys0;
 } else { /// neni prvni, zaradime na konec
  msys9->next=malloc0(sizeof(menusystem));
  msys9=msys9->next;
 } 
 msys9->id=strdup(name);
 msys9->menu=menu_from_def(def);
}

/** smaze menui s nazvem v param */
void cmd_delmenu(const char *param) {
 menusystem *ms=msys0,*msp=0;
 while(ms) {
  if (eqi(ms->id,param)) {
   if (msp) { //zachovat zretezeni
    msp->next=ms->next;
   } else { //byl to prvni v seznamu -> da se novy zacatek
    msys0=ms->next;
   }
   if (!ms->next) msys9=msp;//uz za tim nic neni -> nutno nastavit msys9 - odkaz na posledni
   if (activemenu.type==mtype_simple && activemenu.menucontent.menu==ms->menu) {//menu se pouzivalo - bylo odstraneno
    menu_destroy();
   }
   free(ms->id);
   free(ms->menu->label);
   free(ms->menu->command);
   free(ms->menu);
   free(ms);
   return;
  }
  msp=ms;//predchozi menu
  ms=ms->next;
 }
 //menu nenalezeno - neni co mazat
}

/** vypoise na konzoli seznam definovanych menu */
void cmd_listmenu(const char *param) {
 menusystem *ms=msys0;
 con_printf("Menus:");
 while(ms) {
  con_printf("%s",ms->id);
  ms=ms->next;
 }
 unused(param);
}

/** prida menu, prvni parametr nazev, zbytek definice */
void cmd_addmenu(const char *param) {
 char *param0;
 param0=str_chop_until((char **)&param," ");
 cmd_delmenu(param0);//smazat stare
 menu_addmenu(param0,param);//vytvorit nove
 free(param0);
}

/** vytvori system menu. Zatim pouze 1 menu - main */
void init_menus(void) {
 cmd_exec("exec scripts/menu");
// menu_addmenu("main","New game (DYNA);map dyna|New game (2D);generate_2d|New game (3D);generate_3d|Keybindings;menu_bind|Exit;quit");
}

/** ze seznamu menu vybere menu s danym nazvem a vrati ho */
menuitem *menu_getbyname(const char *menu) {
 menusystem *msys;
 for (msys=msys0;msys;msys=msys->next) {//nalezeni spravneho menu
  if (!stricmp(msys->id,menu)) {
   return msys->menu;
  }
 }
 return 0;
}

/** vyvola menu s danym nazvem (pokud existuje, jinak neudela nic) */
void cmd_menu(const char *param) {
 menuitem *menu;
 menu_destroy();
 activemenu.menucontent.menu=menu_getbyname(param);
 if (!activemenu.menucontent.menu) return;
 activemenu.type=mtype_simple;
 menulen=menupos=menuwidth=0;
 menu=activemenu.menucontent.menu;
 while(menu->label) {
  menuwidth=max(strlen(menu->label),(unsigned int)menuwidth);
  menulen++;
  menu++;
 }
 if (!menulen) activemenu.type=mtype_none;
}

/** na dane misto na HUD vypise dany text danou velikosti fontu (+ je absolutni v pixelech, - je relativni v obrazovkach, 0=stejne jako druha souradnice) a barvou pisma (prvni 4 RGBA pipsma, druhe 4 RGBA pozadi)*/
void hud_show(client *c,hud_position hp,char *btext,bfloat sizex,bfloat sizey,byte r,byte g,byte b,byte a,byte br,byte bg,byte bb,byte ba) {
 bfloat ofsx,ofsy,micx,micy,dimx,dimy;
 int l=strlen(btext);
 int px,py;
 int wx,wy;
 if (c) {
  px=c->x1;
  py=c->y1;
  wx=c->x2-px;
  wy=c->y2-py;
 } else {
  px=0;py=0;
  wx=maxx;wy=maxy;
 }
 if (sizex<0) sizex=wx*-sizex;//velikost fontu se prevede na pixely
 if (sizey<0) sizey=wy*-sizey;
 if (sizey==0) sizey=sizex; 
 if (sizex==0) sizex=sizey; 
 glPushMatrix();
 dimx=sizex*l;
 dimy=sizey;
 micx=sizex/4;
 micy=sizey/4;
 switch (hp%hud_top) {
  case hud_center:ofsx=(wx-dimx)/2;break;
  case hud_right:ofsx=wx-dimx-micx;break;
  /*case hud_left*/default:ofsx=micx;break;
 }
 switch (hp-(hp%hud_top)) {
  case hud_vcenter:ofsy=(wy-dimy)/2;break;
  case hud_bottom:ofsy=wy-dimy-micy;break;
  /*case hud_top*/default:ofsy=micy;break;
 }
 glerr("hud_show: begin");
 glTranslatex(ofsx,ofsy,0);
 glScalex(sizex/fontsizex,sizey/fontsizey,1);
 if (ba) {
  glColor4ub(br,bg,bb,ba);
  gl_settexture(0);
  glBegin(GL_POLYGON);
  glVertex3x((l+0.25)*fontsizex,-fontsizey/4.0,0);
  glVertex3x((l+0.25)*fontsizex,fontsizey*1.25,0);
  glVertex3x(    -fontsizex/4.0,fontsizey*1.25,0);
  glVertex3x(    -fontsizex/4.0,-fontsizey/4.0,0);
  glEnd();
//  glEnable(GL_TEXTURE_2D);
 }
 glColor4ub(r,g,b,a);
 gltext(btext);
 glPopMatrix();
 glerr("hud_show: end");
}

/** ukonci intermission (pokud nejaka byla) */
void intermission_end() {
 if (intermis) {
  if (intermis->text) free(intermis->text);
  if (intermis->title) free(intermis->title);
  if (intermis->aftercommand) free(intermis->aftercommand);
  free(intermis);
  intermis=0;
 }
}

/** zapocne intermission. Behem intermission se neupdatuje fyzika */
void intermission_start(const char *title, const char *text) {
 intermission_end();//pokud predtim nejaka bezela, tak skonci. ale stavat by se to stejne nemelo.
 intermis=malloc1(sizeof(intermission));
 intermis->title=strdup(title);
 intermis->text=strdup(text);
 intermis->start_tick=gettickcount();
 intermis->timeout=3000;
 intermis->aftercommand=strdup("menu main");
}

/** pokud je stav intermission, zobrazi finalni screen */
void intermission_disp() {
 if (intermis) {
  if (intermis->title) hud_show(0,hud_center+hud_top,intermis->title,-0.05,0,200,255,255,255,128,128,128,128);
  if (intermis->text) hud_show(0,hud_center+hud_vcenter,intermis->text,fontsizex,fontsizey,255,255,255,255,128,128,128,128);
 }
}

//todo: mozna sem nasypat ostatni hud funkce