#include "bilbo.h"
#include "b_config.h"
#include "b_types.h"
#include "b_gl.h"
#include "b_con.h"
#include "b_model3d.h"
#include "b_world.h"

#define menuborder_y 1.5 //vertikalni okraj menu (v pismenkach)
#define menuborder_x 1.5 //horizontalni okraj menu (v pismenkach)
#define menu_alpha 160 	// transparence menu (0-255)
#define menu_active_r 255 //barva aktivniho menu
#define menu_active_g 255 //barva aktivniho menu
#define menu_active_b 128 //barva aktivniho menu
#define menu_font_alpha 255 // transparence fontu v menu (0-255)
#define menu_inactive_r 192 //barva neaktivniho menu
#define menu_inactive_g 64  //barva neaktivniho menu
#define menu_inactive_b 0   //barva neaktivniho menu

#define max_keys_on_action 4 //maximalni pocet klaves na jednu akci nabindovatelnych v menu (na konzoli lze nabindovat neomezeny pocet)

typedef enum {
 mtype_none=0,  //na obrazovce nic neni
 mtype_simple,  //jednoduche menu
 mtype_bind,    //nastavovani bindu
 mtype_set,     //nastavovaci menu
 mtype_text     //zobrazen nejaky text (napoveda, atd ...)
} active_menu_type;//typ menu prave aktivniho na obrazove

typedef enum {
 smt_text,      //popisny text
 smt_int,       //integer
 smt_float,     //float
 smt_str,       //string
 smt_vector,    //obyc vektor
 smt_color      //vektor jako barva
} set_menu_type;//typ menu prave aktivniho na obrazove

typedef struct {
 set_menu_type type;//typ hodnoty, ktera se nastavuje
 char *caption; //popisek
 char *var;     //hodnota
} setmenuitem;

typedef struct { // struktura 
 active_menu_type type;//typ menu, ktere je prave aktivni
 int count;//pocet prvku v menu/delka textu ... zavisi na typu menu
 union {
  menuitem *menu;//ukazatel na aktivni menu - jednoduche
  setmenuitem *smenu;//ukazatel na aktivni menu - nastavovaci
  char *text;//je-li nastaveno zobrazeni textu
 } menucontent;
} active_menu;

typedef struct { //tab (zalozka) v menu
 char *caption;//popisek zalozky
 void *data;//data - obsah zalozky
 int pixelsize;//velikost (sirka) tagu zalozky v pixelech
 vp_fn *destructor;//funkce na odalokaci dat (NULL = zavolame obyc. free)
 int count;//pocet dat v zalozce
 int typ;//typ tabu: obecne nejaky integer/konstanta
} tab;

typedef struct { // system zalozek
 tab *t;//definice jednotlivych zalozek
 int num;//nejvyssi zalozka (pocet zalozek)
} tabs;

typedef struct {  // jednoduchy binding - akce a k tomu az max_keys_on_action klavesy.
 char *name;//odkaz na staticky retezec se jmenem bindu
 int action;//akce ke ktere to patri
 int keys[max_keys_on_action];//klavesy prirazene (0=nic)
 char *command;//odkaz na staticky retezec se jmenem comandu (pouzito pokud action je -1)
} menu_bind;

#define ICON_HEALTH "\x01" //tomuto ascii kodu odpovida ikonka zdravi
#define ICON_DEATH  "\x02" //ikonka lebky
#define ICON_BOMB   "\x03" //ikonka bomby

typedef enum {//pozice textu na HUD, muze (musi) byt kombinaci horizontalniho a vertikalniho umisteni
 hud_left,//horizontalni
 hud_center,
 hud_right,
 hud_top,//vertikalni
 hud_vcenter=hud_top*2,
 hud_bottom=hud_top*3,
} hud_position;

typedef struct {//struktura pouzita u intermission screenu (napr. po dosazeni fraglimitu)
 char *text;//text intermise
 char *title;//titulek intermise
 uint start_tick;//kdy intermise zacala
 int timeout;//za kolik milisekund se spusti aftercommand
 char *aftercommand;//co se spusti po konci intermise
} intermission;

