#!/usr/bin/perl
use strict;
use POSIX;

my $cwd=getcwd();
$cwd=~s/\//\\/g;
my $dbfile="_b_doc.dbd";
my $warnfile="_b_warn.txt";
my $perl=$cwd."\\..\\perl_w\\bin\\perl";
my $sourcedir="..";
my $userdoc="user";
my $devdoc="dev";

unlink($dbfile);
unlink($warnfile);

#user documentation
print "Creating user documentation\n";
mkdir($userdoc);
system("copy q.css $userdoc\\q.css >nul");
print "gen_cmd\n";
system("$perl gen_cmd.pl en 0 <..\\b4d.c >$userdoc\\commands.en.htm");
system("$perl gen_cmd.pl cz 0 <..\\b4d.c >$userdoc\\commands.htm");
system("$perl gen_cmd.pl en 1 <..\\b4d.c >$devdoc\\commands.en.htm");
system("$perl gen_cmd.pl cz 1 <..\\b4d.c >$devdoc\\commands.htm");
print "gen_ent\n";
chdir("..");
system("$perl autohead.pl b_ai");
chdir("doc");
system("$perl gen_ent.pl en <..\\b_ai.c >$devdoc\\ent.en.htm");
system("$perl gen_ent.pl cz <..\\b_ai.c >$devdoc\\ent.htm");

opendir(XD,$sourcedir);
my $n=0;
while (my $i=readdir(XD)){
 $_=$i;
 if (/^.*\.(c|cpp|h)$/i) {
  print "Parsing $_\n";
  system("$perl b_pdoc.pl $sourcedir/$_ $dbfile >>$warnfile");
  $n++;
 }
}
closedir(XD);
if ($n>0) {
 system("$perl b_hdoc.pl $dbfile");
} else {
 print("No source files found\n")
}
