/*** Program na vypis informaci o graficke karte */
#ifdef _WIN32
#pragma comment( lib, "opengl32.lib" )
#pragma comment( lib, "glu32.lib" )
#pragma comment( lib, "glut32.lib" )
#pragma comment( lib, "glaux.lib" )

#include <windows.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glut.h>

/** zjisti z OpenGL danou konstantu a vytiskne ji */
void glprintfi(char *desc,char *name,int what,int min) {
 int val=-1;
 glGetIntegerv(what,&val);
 printf("%-29s:%5d (def %3d) %s\n",name,val,min,desc);
}

/**  zjisti z OpenGL danou konstantu (souradnice) a vytiskne je */
void glprintfi2(char *desc,char *name,int what) {
 int val[2]={-1,-1};
 glGetIntegerv(what,val);
 printf("%-29s: %5d,%5d    %s\n",name,val[0],val[1],desc);
}

/** main */
int main(int argc,char** argv){
 glutInit(&argc,argv);
 glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
 glutInitWindowSize(100,100);
 glutInitWindowPosition(0,0);
 glutCreateWindow("?");
 printf("OpenGl version: %s\n",glGetString(GL_VERSION));
 printf("Gl vendor: %s\n",glGetString(GL_VENDOR));
 printf("Gl renderer: %s\n",glGetString(GL_RENDERER));
 printf("Gl extensions: %s\n",glGetString(GL_EXTENSIONS));
 glprintfi("Max number of clipping planes","GL_MAX_CLIP_PLANES",GL_MAX_CLIP_PLANES,6);
 glprintfi("Max texture dimension","GL_MAX_TEXTURE_SIZE",GL_MAX_TEXTURE_SIZE,64);
 glprintfi("Max number of lights","GL_MAX_LIGHTS",GL_MAX_LIGHTS,8);
 glprintfi("Max modelview-matrix stack","GL_MAX_MODELVIEW_STACK_DEPTH",GL_MAX_MODELVIEW_STACK_DEPTH,32);
 glprintfi("Max projection-matrix stack","GL_MAX_PROJECTION_STACK_DEPTH",GL_MAX_PROJECTION_STACK_DEPTH,2);
 glprintfi("Max texture-matrix stack","GL_MAX_TEXTURE_STACK_DEPTH",GL_MAX_TEXTURE_STACK_DEPTH,2);
 glprintfi("Bits of subpixel precision","GL_SUBPIXEL_BITS",GL_SUBPIXEL_BITS,4);
 glprintfi("Max glPixelMap translation table size","GL_MAX_PIXEL_MAP_TABLE",GL_MAX_PIXEL_MAP_TABLE,32);
 glprintfi("Max selection-name stack","GL_MAX_NAME_STACK_DEPTH",GL_MAX_NAME_STACK_DEPTH,64);
 glprintfi("Max display-list nesting","GL_MAX_LIST_NESTING",GL_MAX_LIST_NESTING,64);
 glprintfi("Max evaluator polynomial order","GL_MAX_EVAL_ORDER",GL_MAX_EVAL_ORDER,8);
 glprintfi("Max attribute stack","GL_MAX_ATTRIB_STACK_DEPTH",GL_MAX_ATTRIB_STACK_DEPTH,16);
 glprintfi("Number of auxiliary buffers","GL_AUX_BUFFERS",GL_AUX_BUFFERS,-1);
 glprintfi("Color buffers store RGBA","GL_RGBA_MODE",GL_RGBA_MODE,-1);
 glprintfi("Color buffers store indexes","GL_INDEX_MODE",GL_INDEX_MODE,-1);
 glprintfi("Front and back buffers exist","GL_DOUBLEBUFFER",GL_DOUBLEBUFFER,-1);
 glprintfi("Left and right buffers exist","GL_STEREO",GL_STEREO,-1);
 glprintfi2("Maximum viewport dimensions","GL_MAX_VIEWPORT_DIMS",GL_MAX_VIEWPORT_DIMS);
 return 0;
}
